CC    New: april 2010

CC    Now evolution from resummation scale to b0^2/b^2

CC    Now the variable final must be b0^2/b^2 (to be set in auto.f)


      subroutine evolfast(final,qqb,qg,gg)
      implicit double precision (A-H,O-Z)
      integer f,flag,flag1,flag4
      integer iord
      real*8 q2s,lambda
      complex*16 alphas,all,final,ff
      complex *16 qqb,qg,gg
      common/flag/flag
      common/flag1/flag1
      common/flag4/flag4
      common/isetproton/isetproton
      common/order/iord 
      common/CUV/A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      common/CDV/A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      common/CUS/A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      common/CDS/A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      common/CSS/A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      common/CGL/A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      common/CCH/A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      common/CBO/A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      save/CUV/
      save/CDV/
      save/CUS/
      save/CDS/
      save/CSS/
      save/CGL/
      save/CCH/
      save/CBO/
      common/scales/q2s,lambda
      common/scheme/N
      common/nloop/nloop
      common/xlam/xlam
      common/nf/f
      common/idistr/idist
c     common/x/x,q2,q20
      common/ippbar/ippbar
!
      common/a_param/a_param,b0p
!      external xqq,xqg,xgg
      include 'scales.h'
      
      data N/1/              !MSBAR SCHEME


c.....NEW: Start evolution from resummation scale


      q2s=q2/a_param**2


C.....Here call the program to fit the pdfs at q2 around 'x'
CNew.....Here call the program to fit the pdfs at muF around 'x'
      xtauf=muf2/shad!xtau

      if (flag.eq.0) then
         call fiter(1,xtauf,muf2,
     /        A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV)
         call fiter(2,xtauf,muf2,
     /        A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV)
         call fiter(3,xtauf,muf2,
     /        A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US)
         call fiter(4,xtauf,muf2,
     /        A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS)
         call fiter(5,xtauf,muf2,
     /        A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS)
         call fiter(6,xtauf,muf2,
     /        A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL)
         call fiter(7,xtauf,muf2,
     /        A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH)
         call fiter(8,xtauf,muf2,
     /        A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO)

c.....NEW: Make grid

!      call gridmaker

C.....Initialize evolution code
      call init 
      call inp200 

      write(*,*)'( ...fit completed'
      write(*,*)'(                 '
      endif
      flag=1 

c.....Compute distributions/luminosities at Q2 from evolution from Q20
      call evol (xtau,final,uv,dv,us,ds,ss,gl,qqb,qg,gg)


      return
      end
      
      subroutine fiter(idist,x,q2,a1,a2,a3,a4,a5,a6,a7,a8)
      implicit double precision (A-H,O-Z)
      external fcng1,chi2
      dimension nprm(8), vstrt(8),stp(8),bl(8),bu(8),arglis(16) 
      dimension parsal(8)
      character*10 pnam(8) 
      data nprm /1,2,3,4,5,6,7,8/  
      data pnam  / 'A1','A2','A3','A4','A5', 'A6', 'A7', 'A8'/
      data vstrt /  1D0, -.1D0, 5D0, 3D0, -1D0, 0D0, 0D0, 0D0/
      data stp   /  1D0, 1D0, 1D0, 10D0, 15D0, 25D0, 25D0, 25D0/
c      data bl    /0D0, -0.8D0, 4D0, -20D0, -40D0, -80D0,-80D0,-80D0/
c      data bu    /0D0, 1.5D0, 19D0, 600D0, 40D0, 80D0, 80D0, 80D0/

c      data bl    /0D0, -0.8D0, 5D0, -5D0, -30D0, -30D0,-30D0,-30D0/
c      data bu    /0D0, 1.2D0, 12D0, 50D0, 30D0, 30D0, 30D0, 30D0/

!      data bl  /0D0, 0D0, 0D0, 0D0, 0D0, 0D0, 0D0,0D0/
!      data bu  /0D0, 0D0, 0D0, 0D0, 0D0, 0D0, 0D0, 0D0/

!      data bl  /0D0, -1D0, 2D0,  -100D0, -10D0, -100D0, -400D0,-50D0/
!      data bu  /2D0, 20D0, 15D0,   30D0,  20D0,  300D0, 100D0, 600D0/


!      data bl  /0D0,-0.8D0,-16D0,-300D0, -60D0, -240D0,-240D0,-200D0/
!      data bu  /0D0, 1.5D0, 25D0, 600D0, 180D0, 240D0, 240D0, 180D0/

      data bl    /0D0, -0.8D0, 4D0, -20D0, -60D0, -90D0,-90D0,-90D0/
      data bu    /0D0, 1.5D0, 25D0, 600D0, 60D0, 90D0, 90D0, 90D0/

      common/sal/parsal
      common/distribucion/id
      common/xq2/rx,rq2
      id=idist
      rx=x
      rq2=q2
c.....initialization :
      call mninit(5,1,1)
c     call mninit(5,6,6)
c.....definitions of the parameters :
      do 11 i = 1, 8
         call mnparm (nprm(i),pnam(i),VSTRT(i),STP(i),BL(i),BU(i),
     .        ierflg,chi2)
         if (ierflg .ne. 0) then
            write (6,*) ' unable to define parameter no.', i
            stop
         end if
 11   continue
c.....output  
      arglis(1) = 0.
      call mnexcm(fcng1,'set print',arglis,1,ierflg,chi2)
c.....first call :
      arglis(1) = 1.            !   IFLAG = 1 
      call mnexcm(fcng1,'CALL FCN',arglis,1,ierflg,chi2)
c.....simplex fit :
   
c      goto 100

      arglis(1)=5000.
      call mnexcm(fcng1,'SIMPLEX',arglis,1,ierflg,chi2)
      call mnexcm(fcng1,'MIGRAD',arglis,1,ierflg,chi2)
      
      arglis(1)=20000.
      call mnexcm(fcng1,'SIMPLEX',arglis,1,ierflg,chi2)
      call mnexcm(fcng1,'MIGRAD',arglis,1,ierflg,chi2)
      arglis(1)=28000.
      call mnexcm(fcng1,'SIMPLEX',arglis,1,ierflg,chi2)
      call mnexcm(fcng1,'MIGRAD',arglis,1,ierflg,chi2)
 100  continue     

c      arglis(1)=500.
c      call mnexcm(fcng1,'SIMPLEX',arglis,1,ierflg,chi2)
c      call mnexcm(fcng1,'MIGRAD',arglis,1,ierflg,chi2)

cc.....last call :
      arglis(1) = 3             !   iflag = 3
      call mnexcm (fcng1, 'call fcn', arglis, 1, ierflg,chi2)
c.....stop :
      call mnexcm (fcng1,'stop',arglis,1,ierflg,chi2)
      a1=parsal(1)
      a2=parsal(2)
      a3=parsal(3)
      a4=parsal(4)
      a5=parsal(5)
      a6=parsal(6)
      a7=parsal(7)
      a8=parsal(8)
 1200 format(4F8.4)

      
c      call distri(rx,q,upv,dnv,usea,dsea,str,chm,bot,glu,ippbar)
c      call evol (rx,cmplx(q*q),uv,dv,us,ds,ss,gl,qqb,qg,gg)
c       write(6,*)rx,glu/gl
      

      return
      end
      
      subroutine fcng1 (npar, g, f, x, iflag ,chi2)
      implicit double precision (a-h, o-z)
      dimension x(*), g(*)
      external chi2 
      f = chi2 (x)
      return
      end
      
c     NEW version of chi2 from Daniel

      
      double precision function chi2(param)
      implicit double precision (a-h,o-z)
      dimension param(8),xx2(74),xx1(228)
!      dimension param(8),xx1(63)
      dimension parsal(8)
      common/sal/parsal
      common/distribucion/id
      common/xq2/rx,rq2
      common/exp/aa
c      data npoints/63/
       data npoints/228/
!      data npoints/74/

      data xx2/1.d-5,2.d-5,4.d-5,6.d-5,8.d-5,9D-5,
     .     1.D-4,2.D-4,3.D-4,4.D-4,5.D-4,6.D-4,8.D-4,
     .     1.D-3,2.D-3,3D-3,4.D-3,5.D-3,6.D-3,7D-3,8d-3,9d-3,
     .     1.D-2,2.D-2,3D-2,4.D-2,5D-2,
     .     6.D-2,6.5d-2,7D-2,7.5d-2,8.D-2,8.5d-2,9d-2,9.5d-2,
     .     .1D0,.11d0,.125D0,.15D0,.175D0,.2D0,.225D0,.25D0,.275D0,
     .     .3D0,.325D0,.35D0,.375D0,.4D0,.425D0,.45D0,.475D0,
     .     .5D0,.525D0,.55D0,.575D0,.6D0,
     .     .625d0,.65d0,.675d0,.7d0,.725d0,.75d0,.775d0,.8d0,
     .     .825d0,.85d0,.875d0,.9d0,.92d0,.94d0,.96d0,.98d0,1d0/  !74

!     .     1.D-3,2.D-3,3D-3,4.D-3,5.D-3,5.5D-3,6.D-3,6.5D-3,
!     .     7D-3,7.5D-3,8d-3,8.5D-3,9d-3,9.5D-3,
!

      data xx1/1.d-5,2.d-5,3.d-5,4.d-5,5.d-5,6.d-5,7.d-5,8.d-5,9D-5,
     . 1.D-4,1.5D-4,2.D-4,2.5D-4,3.D-4,3.5D-4,4.D-4,4.5D-4,5.D-4,
     . 5.5D-4,6.D-4,6.5D-4,7.D-4,7.5D-4,8.D-4,8.5D-4,9.D-4,9.5D-4,
     .0.001,0.0015,0.002,0.0025,0.003,0.0035,0.004,0.0045,0.005,
     .0.0055,0.006,0.0065,0.007,0.0075,0.008,0.0085,0.009,0.0095,
     .0.01,0.015,0.02,0.025,0.03,0.035,0.04,0.045,0.050,
     .0.055,0.06,0.065,0.07,0.075,0.08,0.085,0.09,0.095,
     .0.1,0.105,0.11,0.115,0.12,0.125,0.13,0.135,    
     .0.14,0.145,0.15,0.155,0.16,0.165,0.17,0.175,0.18,   !80
     .0.185,0.19,0.195,0.20,0.205,    
     .0.21,0.215,0.22,0.225,0.23,0.235,    
     .0.24,0.245,0.25,0.255,0.26,0.265,0.27,0.275,0.28,0.285,0.29,0.295,    
     .0.30,0.305,0.31,0.315,0.32,0.325,0.33,0.335,0.34,0.345,0.35,0.355,
     .0.36,0.365,0.37,0.375,0.38,0.385,0.39,    
     .0.395,0.40,0.405,0.41,0.415,0.42,0.425,0.43,0.435,0.44,.445,0.45,  !134
     .0.455,0.46,0.465,0.47,0.475,0.48,0.485,0.49,0.495,0.50,0.505,    
     .0.51,0.515,0.52,0.525,0.53,0.535,0.54,0.545,0.55,0.555,0.56,
     .0.565,0.57,0.575,0.58,0.585,0.59,0.595,0.60,0.605,0.61,0.615,0.62,
     .0.625,0.63,0.635,0.64,0.645,0.65,0.655,0.66,0.665,0.67,0.675,0.68,  !180
     .0.685,0.69,0.70,0.705,0.71,0.715,0.72,0.725,0.73,0.735,0.74,
     .0.745,0.75,0.755,0.76,0.765,0.77,0.78,.785,
     .0.79,0.795,0.80,0.805,0.81,
     .0.815,0.82,0.825,0.83,0.835,
     .0.84,0.845,0.85,
     .0.855,0.86,0.865,0.87,0.875,
     .0.88,0.885,0.89,0.895,0.90,
     .0.91,0.93,0.95,0.97,0.99,1.0/! 228 


  

      a1=(param(1))
      a2=(param(2))
      a3=(param(3))
      a4=(param(4))
      a5=(param(5))
      a6=(param(6))
      a7=(param(7))
      a8=(param(8))
      chi2=0.d0
      
c.....aa can be changed to try to improve the fit
c.....the common changes it at the same time in the subroutine f0moments
      aa=2.5
      
c.....take less/more points to improve speed/accuracy
      do i=1,npoints,1
         x=rx**( (1-xx1(i))/2.)
         f=a1*x**a2*(1-x)**a3*(1+a4*x+a5*x**(0.5)+a6*x**(1.5)+A7*X**2
     .        +A8*X**(aa))

         call distri(x,dsqrt(rq2),unv,dnv,us,ds,str,chm,bot,glu,1)
         if(id.eq.1) then
            f2=unv
         elseif(id.eq.2) then
            f2=dnv
         elseif(id.eq.3) then
            f2=us
         elseif(id.eq.4) then
            f2=ds
         elseif(id.eq.5) then
            f2=str
         elseif(id.eq.6) then
            f2=glu
         elseif(id.eq.7) then
            f2=chm
         elseif(id.eq.8) then
            f2=bot
         endif
        aaa=1d0
         if (x.lt.rx)   aaa=30d0 

         chi2=chi2+(f2-f)**2*aaa*x**1.2  

      enddo

      do i=1,npoints,1
         x=rx**( (1+xx1(i))/2.)     
         f=a1*x**a2*(1-x)**a3*(1+a4*x+a5*x**(0.5)+a6*x**(1.5)+A7*X**2
     .        +A8*X**(aa))         
         call distri(x,dsqrt(rq2),unv,dnv,us,ds,str,chm,bot,glu,1)
         if(id.eq.1) then
            f2=unv
         elseif(id.eq.2) then
            f2=dnv
         elseif(id.eq.3) then
            f2=us
         elseif(id.eq.4) then
            f2=ds
         elseif(id.eq.5) then
            f2=str
         elseif(id.eq.6) then
            f2=glu
         elseif(id.eq.7) then
            f2=chm
         elseif(id.eq.8) then
            f2=bot
         endif
         aaaa=1d0
         if (x.gt.rx)  aaaa=30d0
         if(id.gt.2) then         
         chi2=chi2+(f2-f)**2*x**1.2 
         elseif(id.eq.1) then
         chi2=chi2+(f2-f)**2 
         elseif(id.eq.2) then
         chi2=chi2+(f2-f)**2 
         endif
        enddo
      
C.....return the parameters to save the last set
      do i=1,8
         parsal(i)=param(i)
      enddo
      return
      end  
      
       
     
     
      subroutine distri(x,q,upv,dnv,usea,dsea,str,chm,bot,glu,ippbar)
C.....here I call the new  sets !!!!! (in program prog_pdf.f)
C.....gives always x*distribution!!!!!
C.....MODIFICA MIA sett. 2004
      implicit none
      real*8 upv,dnv,usea,dsea,str,chm,bot,glu,x,q,q2
      integer isetproton,ippbar
      common/isetproton/isetproton
      REAL *8 FX(-5:5)
      q2=q*q
c      sx=dble(x)
      call partons(q2,x,fx,5,isetproton,ippbar)
      usea=fx(-1)*x
      dsea=fx(-2)*x
      str=fx(-3)*x
      chm=fx(-4)*x
      bot=fx(-5)*x
      glu=fx(0)*x
      upv=fx(1)*x-usea 
      dnv=fx(2)*x-dsea
      return
      end
      
      
C.....PSI - FUNCTION FOR COMPLEX ARGUMENT
      COMPLEX*16 FUNCTION PSIFN (Z)
      COMPLEX*16 Z, ZZ, RZ, DZ, SUB, CDLOG
      SUB = DCMPLX (0.,0.)
      ZZ = Z
 1    CONTINUE
      IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB - 1./ ZZ
         ZZ = ZZ + 1.
         GOTO 1
      END IF
      RZ = 1./ ZZ
      DZ = RZ * RZ
      PSIFN = SUB + CDLOG(ZZ) - RZ/2.- DZ/2520. * ( 210.+ DZ * (-21.+
     1     10.*DZ ))
      RETURN
      END
C     
C.....FIRST DERIVATIVE OF THE PSI - FUNCTION FOR COMPLEX ARGUMENT :
      COMPLEX*16 FUNCTION PSIFN1 (Z)
      COMPLEX*16 Z, ZZ, RZ, DZ, SUB
      SUB = DCMPLX (0.,0.)
      ZZ = Z
 1    CONTINUE
      IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB + 1./ (ZZ * ZZ)
         ZZ = ZZ + 1.
         GOTO 1
      END IF
      RZ = 1./ ZZ
      DZ = RZ * RZ
      PSIFN1 = SUB + RZ + DZ/2. * ( 1 + RZ/630. * ( 210.- DZ * ( 42.-
     1     DZ * ( 30.- 42.*DZ ))))
      RETURN
      END
C     
C.....SECOND DERIVATIVE OF THE PSI - FUNCTION FOR COMPLEX ARGUMENT :
      COMPLEX*16 FUNCTION PSIFN2 (Z)
      COMPLEX*16 Z, ZZ, RZ, DZ, SUB
      SUB = DCMPLX (0.,0.)
      ZZ = Z
 1    CONTINUE
      IF (DREAL (ZZ) .LT. 10.) THEN
         SUB = SUB - 2./ (ZZ * ZZ * ZZ)
         ZZ = ZZ + 1.
         GOTO 1
      END IF
      RZ = 1./ ZZ
      DZ = RZ * RZ
      PSIFN2 = SUB - DZ/60. * ( 60.+ RZ * ( 60.+ RZ * ( 30.- DZ *
     1     ( 10.- DZ * ( 10.- DZ * ( 18.- 50.* DZ ))))))
      RETURN
      END
C     
C.....BETA FUNCTION FOR COMPLEX ARGUMENT :
      COMPLEX*16 FUNCTION CBETA (Z1, Z2)
      implicit COMPLEX*16 (A - Z)
      LNGAM (X) = (X - 0.5) * CDLOG (X) - X + 0.91893853 + 1./(12.* X)
     1     * (1.- 1./(30.* X*X) * (1.- 1./(3.5 * X*X)
     2     * (1.- 4./(3.* X*X))))
      SUB = DCMPLX (0., 0.)
      ZZ1 = Z1
 1    CONTINUE
      IF ( DREAL (ZZ1) .LT. 15.) THEN
         SUB = SUB + CDLOG ((ZZ1+Z2) / ZZ1)
         ZZ1 = ZZ1 + 1.
         GOTO 1
      END IF
      ZZ2 = Z2
 2    CONTINUE
      IF ( DREAL (ZZ2) .LT. 15.) THEN
         SUB = SUB + CDLOG ((ZZ1+ZZ2) / ZZ2)
         ZZ2 = ZZ2 + 1.
         GOTO 2
      END IF
      LG1 = LNGAM (ZZ1)
      LG2 = LNGAM (ZZ2)
      LG12 = LNGAM (ZZ1 + ZZ2)
      CBETA = CDEXP (LG1 + LG2 - LG12 + SUB)
      RETURN
      END
C     
C.....DOUBLE PRECISE GAUSS INTEGRATION :
      FUNCTION DINTEG (F, ALFA, BETA, EPS, K)
      implicit double precision (A-H, O-Z)
      dimension W(12), X(12)
      common / DIST / L
      data CONST / 1.0 D-12 /
      data W
     1 /0.101228536290376d0, 0.222381034453374d0, 0.313706645877887d0,
     2  0.362683783378362d0, 0.027152459411754d0, 0.062253523938647d0,
     3  0.095158511682492d0, 0.124628971255533d0, 0.149595988816576d0,
     4  0.169156519395002d0, 0.182603415044923d0, 0.189450610455068d0/
      data X
     1 /0.960289856497536d0, 0.796666477413627d0, 0.525532409916329d0,
     2  0.183434642495650d0, 0.989400934991649d0, 0.944575023073232d0,
     3  0.865631202387831d0, 0.755404408355003d0, 0.617876244402643d0,
     4  0.458016777657227d0, 0.281603550779258d0, 0.095012509837637d0/
      DINTEG = 0.0 D0
      M = 0
      L = K
      IF ( ALFA . EQ. BETA ) RETURN
      A = ALFA
      B = BETA
      DELTA = CONST * (DABS(A-B))
      AA = A
 1    Y = B - AA
      IF( DABS(Y) .LE. DELTA ) RETURN
C     IF( DABS(Y) .LE. DELTA ) THEN
C     WRITE (*,*) M
C     RETURN
C     END IF
 2    BB = AA + Y
      C1 = 0.5 D0 * (AA + BB)
      C2 = C1 - AA
      S8 = 0.0 D0
      S16 = 0.0 D0
      DO 15 I = 1, 4
         C3 = X(I) * C2
         S8 = S8 + W(I) * (F(C1+C3) + F(C1-C3))
 15   CONTINUE
      DO 16 I = 5, 12
         C3 = X(I) * C2
         S16 = S16 + W(I) * (F(C1+C3) + F(C1-C3))
  16   CONTINUE
       S8 = S8 * C2
       S16= S16 * C2
       IF( DABS(S16-S8) .GT. EPS * DABS(S8)) THEN
          Y = 0.5 * Y
          M = M + 1
          IF ( DABS(Y) .LE. DELTA ) THEN
             DINTEG = 0.0
             WRITE (*,10)
 10          FORMAT (1X,' DINTEG : TOO HIGH ACCURACY ')
          ELSE
             GOTO 2
          END IF
       ELSE
          DINTEG = DINTEG + S16
          AA = BB
          GOTO 1
       END IF
       RETURN
       END

      function alphasl(nq2)
      implicit none
      real *8 a_param,b0p,as
      complex*16 xlambda,aa1,all,alphasl,nq2,qq,t,xlt,bstar,b,blog
      integer flagrealcomplex,imod,iord
      common/order/iord
      common/asNEW/as
      common/flagrealcomplex/flagrealcomplex
      common/modified/imod
      common/a_param/a_param,b0p
      include 'scales.h'
      include 'const.h'

c.....Here computes NLL expression for alphas
c     here nq2=b0^2/b^2 and the result is now  alpha(nq2)/alpha(muf2)  


      b=b0/nq2**(0.5)

      blog=cdlog((q*b/(b0p))**2+1) !=Log(Q2 b^2/b0^2+1) where Q2 is the resummation scale

      xlambda=beta0*as*blog


c     HERE now a dependence (without constant term)!


      aa1=cdlog(1-xlambda)+as*iord*
     .      (beta1/beta0*cdlog(1-xlambda)/(1-xlambda) 
     .       + beta0*xlambda/(1-xlambda)*dlog(q2/mur2) 
!     .      +    beta0*dlog(q2/muf2)                          ! TOGLIERE  (FATTO)
     .       -2d0*beta0*xlambda*dlog(a_param)/(1-xlambda)   )  
      alphasl=CDExp(-aa1)
      return
      end



      function alphaslB(nq2)
      implicit none
      real *8 a_param,b0p,as
      complex*16 xlambda,aa2,all,alphaslB,nq2,qq,t,xlt,bstar,b,blog
      integer flagrealcomplex,imod,iord
      common/order/iord
      common/asNEW/as
      common/flagrealcomplex/flagrealcomplex
      common/modified/imod
      common/a_param/a_param,b0p
      include 'scales.h'
      include 'const.h'

c.....This function computes the factor Exp(lambda/(1-lambda))
c.....where lambda=beta0*as*blog

c.....This function is needed to resum the logarithms which multiply the 
c.....N-dependent part of the C coefficients (the N-independent part 
c.....is in the f2 function in auto.f).

      b=b0/nq2**(0.5)

      blog=cdlog((q*b/(b0p))**2+1) !=Log(Q2 b^2/b0^2+1) where Q2 is the resummation scale

      xlambda=beta0*as*blog

      aa2=xlambda/(1-xlambda)

      alphaslB=CDExp(aa2)
      return
      end


      subroutine evol (x,q2,uv,dv,us,ds,ss,gl,qqb,qg,gg)
      implicit double precision (a-h, o-z) 
      complex*16 q2
      complex *16 uv,dv,us,ds,ss,gl,qqb,qg,gg,pa
      integer iord,flag4
      dimension pa(9)  
      common/order/iord 
      common/flag4/flag4
c.....call polarized parton distributions
      call inv(pa,x,q2)
c.....*** u,d - valence 
      uv=pa(1)
      dv=pa(2)
c.....*** u,d - sea
      us=pa(3)
      ds=pa(4)
c.....*** s - sea
      ss=pa(5)
c.....*** gluon
      gl=pa(6)
c.....*** luminosities 
      qqb=pa(7) 
      qg=pa(8) 
      gg=pa(9) 
      end
      
*.....Parton density  calculation for the proton at externally fixed 
*     Bjorken-x, XB, and scale Q**2 in GeV**2, QS, calculated via a 
*     Mellin inversion of the analytic RGE solution in RENO.    
*
*.....The integration parameters (for the contour in the complex n-plane
*     and for the Gauss quadrature) are taken from the common-blocks
*     CONT, MOMS and WEIGHTS. 
                  
      subroutine inv(pa,xb,q2)    
      implicit none
      double precision c,xb,wn(136),xxx,q2s,lambda,x,ax,ex
      complex*16 cc(2),xnm(2),cdex(2),n(2,136),alps,
     .     fn(2,137,9),q2,II,fz,alphasl,alphaslB,alphas,aexp,aexpB
      complex *16 pa(9),fun
      integer nmax, i1, i2, m, iord, kp, flag4
      common/scales/q2s,lambda
      common/coupl/alps,aexp,aexpB
      common/contin/c,cc                              
      common/weights/wn
      common/moms/n
      common/order/iord
      common/flag4/flag4
      II=dcmplx(0.0,1.0)

*...  coupling constants at static point, input scale :
      alps=alphas(dcmplx(q2s,0d0))
*... alphasl gives the LL/NLL evolution of alpha from Q2 to b0^2/b^2
      aexp=alphasl(q2)
*... needed to resum xlam/(1-xlam)
      aexpB=alphaslB(q2)

*...  q2 and x dependent quantities : 
      x=xb                                    
      ax=dlog(x)                                        
      ex=dexp(-c*ax)                                  
*...  integration length parameter for mellin inversion
c      if ( X .le. 0.001 ) then                          
c         nmax = 24              ! zmax = 2 
c      else if ( X .le. 0.05 ) then                   
c         nmax = 40              ! zmax = 4  
c      else if ( X .le. 0.2 ) then                   
c         nmax = 56              ! zmax = 8  
c      else if ( X .le. 0.4 ) then                   
c         nmax = 72              ! zmax = 12 
c      else if ( X .le. 0.7 ) then                   
c         nmax = 88              ! zmax = 18 
c      else                                                          
c         nmax = 136             ! zmax = 36
c      end if              
      nmax=136
      xxx=1d0                               
*...  calculation of the parton densities and output:
*     index of func :   1     2    3     4    5   6   
*     distribution  :  UV    DV    UB    DB   S   G  
      call reno (fn, n, nmax,iord)
CC      do 2 i2 = 1, 9
         i2=7
         fun=(0d0,0d0)
         if(i2.ge.7) xxx=xb
         do 1 i1 = 1, nmax
            do 3 kp=1,2
               xnm(kp) = (c - n(kp,i1)+1.) * ax
               cdex(kp) = cdexp (xnm(kp)) / 3.1415927 * cc(kp)/2./II
 3          continue
c     fz = dble (aimag (fn(kp,i1+1,i2)*cdex(kp)))
           fz=dcmplx ((( fn(1,i1+1,i2)*cdex(1) -fn(2,i1+1,i2)*cdex(2))))
           fun = fun + wn(i1) * fz
 1       continue
         pa(i2) = fun * ex/xxx
 2    continue
      return                         
      end
      
*...  Mellin-n space Q**2 - evolution of parton densities and structure 
*     functions in next to leading order :
*     (for valence input scale not equal sea/gluon input scale)
*     Output for FN: Array of parton moments 
*     2. index of FN :   1     2      3        4      5   6   7   8 
*     Distribution   :  uv    dv    db-ub    db+ub    s   g  G1P G1N
      
      subroutine reno (fn, n, nmax, iord)
      implicit none
      real *8 pi,beta0,beta1,as,GE,zeta4,zeta2,zeta3,Cf,CA,log2
      real *8 a_param,b0p,loga,A1q,B1q,H1q,A2q,B2q
      complex*16 ans(2,136), am(2,136), ap(2,136), al(2,136),
     1     be(2,136), ab(2,136), ac(2,136), rmin(2,136),
     2     rplus(2,136), C1Q(2,136), C1G(2,136),C3Q(2,136), 
     3     rmmqq(2,136),rmmqg(2,136),rmmgq(2,136) ,rmmgg(2,136),
     4     rmpqq(2,136),rmpqg(2,136),rmpgq(2,136),rmpgg(2,136),
     5     rpmqq(2,136),rpmqg(2,136),rpmgq(2,136),rpmgg(2,136),
     6     rppqq(2,136),rppqg(2,136),rppgq(2,136),rppgg(2,136),
     7     uvi(2,136), dvi(2,136), usi(2,136), dsi(2,136),
     8     ssi(2,136), gli(2,136), chi(2,136), boi(2,136),
     9     fn(2,137,9), n(2,136)
C
C ADDED: Anomalous dimensions used for scale dependence
C
      complex*16 QQIM(2,136),QGFM(2,136),GQIM(2,136),GGIM(2,136),
     #      GGFM(2,136),NS1MIM(2,136),NS1PIM(2,136),NS1FM(2,136),
     #      QQ1FM(2,136),QG1FM(2,136),GQ1IM(2,136),GQ1FM(2,136),
     #      GG1IM(2,136),GG1FM(2,136)

      common/anomdim/QQIM,QGFM,GQIM,GGIM,GGFM,NS1MIM,NS1PIM,NS1FM,
     #      QQ1FM,QG1FM,GQ1IM,GQ1FM,GG1IM,GG1FM

      complex *16 C2qgM(2,136),C2NSqqbM(2,136),
     #          C2NSqqM(2,136),C2SqqbM(2,136)
      common / H2mat / C2qgM,C2NSqqbM,C2NSqqM,C2SqqbM
C
      complex *16 S,XL,XL1,ENS,EM,EP,EMP,EPM,SG,GL,SSN,DSN,USN,CHN
      complex *16 BON,alp,alpn,alps,aexp,aexpB,oswi
      complex *16 QQ1FN,QG1FN,GQ1IN,GQ1FN,GG1IN,GG1FN
      complex *16 gamma1qq,gamma1gq,gamma1qg,gamma1gg
      complex *16 gamma2qqV,gamma2qqS,gamma2qqbV,gamma2qqbS,
     / gamma2gq,gamma2qg,gamma2gg
      complex *16 UVN,DVN,NS3N,NS8N,GLN,SIN,NS15N,NS24N,NS35N
      complex *16 C1qg,C1qq,CGQ,H1stqqb,H1stqg
      complex *16 Hgg,Hqg,Hqqb,Hqq,Hqqp
      complex *16 H2stgg,H2stqg,H2stqqb,H2stqq,H2stqqp
      complex *16 QGN,GGN,QQBARN,qqbn1,gqn1,qgn1,ggn1
C
      INTEGER  F,NF,K1,KK1,NMAX,iord,iiord,KP,flag1,flag4
   
      common / ANOMS  / ANS, AM, AP, AL, BE, AB, AC, RMIN, RPLUS, C1Q, 
     1     C1G, C3Q, RMMQQ, RMMQG, RMMGQ, RMMGG, RMPQQ, RMPQG, RMPGQ, 
     2     RMPGG, RPMQQ, RPMQG, RPMGQ, RPMGG, RPPQQ, RPPQG, RPPGQ, 
     3     RPPGG
      common / INPUT  / UVI, DVI, USI, DSI, SSI, CHI, BOI, GLI
      common/ order/ iiord
      common/nf/nf
      common/coupl/alps,aexp,aexpB
      common/flag1/flag1
      common/flag4/flag4
      common/asNEW/as
      common/a_param/a_param,b0p
!
      real *8 sigmaij
      dimension sigmaij(-5:5,-5:5)
      integer si,sj,sk,ippbar,flagch
      common/sigmaij/sigmaij
      common/ippbar/ippbar
      complex *16 FX1(-5:5), FX2(-5:5)
      common/flagch/flagch
!

      include 'scales.h'

      data pi/3.1415926536d0/
      data zeta3/1.20205690315959429d0/

      iord=iiord
      oswi=dcmplx(iord,0.)
      DO 1 KP=1,2
      DO 1 KK1 = 0, NMAX
      IF(KK1.EQ.0) THEN
         K1=1
      ELSE
         K1=KK1
      ENDIF


      
      UVN = UVI(KP,K1)
      DVN = DVI(KP,K1)
      NS3N = UVI(KP,K1) + 2*USI(KP,K1) - DVI(KP,K1) - 2.*DSI(KP,K1)
      NS8N = UVI(KP,K1) + 2*USI(KP,K1) + DVI(KP,K1) + 2.*DSI(KP,K1)
     .     - 4.*SSI(KP,K1)
      GLN = GLI(KP,K1)
      SIN = UVI(KP,K1) + DVI(KP,K1) + 2*USI(KP,K1) + 2*DSI(KP,K1)
     .     + 2*SSI(KP,K1) + 2*CHI(KP,K1) + 2*BOI(KP,K1)
      NS15N = UVI(KP,K1) + DVI(KP,K1) + 2*USI(KP,K1) + 2*DSI(KP,K1) +
     .     2*SSI(KP,K1) - 6*CHI(KP,K1)
      NS24N = UVI(KP,K1) + DVI(KP,K1) + 2*USI(KP,K1) + 2*DSI(KP,K1) +
     .     2*SSI(KP,K1) + 2*CHI(KP,K1) - 8*BOI(KP,K1)
      NS35N = SIN
      F = 5
C
      XL = 1d0/aexp 
      ALP = alps*aexp
C
      S   = CDLOG (XL)
      XL1 = 1.- XL
      ENS = CDEXP (-ANS(KP,K1)*S)
      EM  = CDEXP (-AM(KP,K1)*S)
      EP  = CDEXP (-AP(KP,K1)*S)
      EMP = EM / EP
      EPM = EP / EM
      
*...  EVOLUTION OF LIGHT PARTON DESITIES BETWEEN THRESHOLDS :
      UVN  = UVN  * ENS * (1.+ oswi * ALP * XL1 * RMIN(KP,K1))
      DVN  = DVN  * ENS * (1.+ oswi * ALP * XL1 * RMIN(KP,K1))
      NS3N = NS3N * ENS * (1.+ oswi * ALP * XL1 * RPLUS(KP,K1))
      NS8N = NS8N * ENS * (1.+ oswi * ALP * XL1 * RPLUS(KP,K1))
      SG = SIN
      GL = GLN
      SIN = EM * ((AL(KP,K1) + oswi * ALP * (RMMQQ(KP,K1) * XL1 
     1     + RMPQQ(KP,K1) * (EPM-XL)))* SG  
     2     + (BE(KP,K1) + oswi * ALP * (RMMQG(KP,K1) * XL1 
     3     + RMPQG(KP,K1) * (EPM-XL))) * GL)
     4     + EP * ((AC(KP,K1) + oswi * ALP * (RPPQQ(KP,K1) * XL1 
     5     + RPMQQ(KP,K1) * (EMP-XL))) * SG
     6     +(-BE(KP,K1) + oswi * ALP * (RPPQG(KP,K1) * XL1 
     7     + RPMQG(KP,K1) * (EMP-XL))) * GL)
      GLN = EM * ((AB(KP,K1) + oswi * ALP * (RMMGQ(KP,K1) * XL1 
     1     + RMPGQ(KP,K1) * (EPM-XL))) * SG 
     2     + (AC(KP,K1) + oswi * ALP * (RMMGG(KP,K1) * XL1 
     3     + RMPGG(KP,K1) * (EPM-XL))) * GL)
     4     + EP *((-AB(KP,K1) + oswi * ALP * (RPPGQ(KP,K1) * XL1 
     5     + RPMGQ(KP,K1) * (EMP-XL))) * SG
     6     + (AL(KP,K1) + oswi * ALP * (RPPGG(KP,K1) * XL1 
     7     + RPMGG(KP,K1) * (EMP-XL))) * GL)
      
      NS15N = NS15N * ENS * (1.+  oswi * ALP * XL1 * RPLUS(KP,K1))
      NS24N = NS24N * ENS * (1.+  oswi * ALP * XL1 * RPLUS(KP,K1))
      NS35N = SIN
      
C...  FLAVOUR DECOMPOSITION OF THE QUARK SEA :
      SSN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N - 20.* NS8N)
     1     / 120.
      DSN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N + 10.* NS8N
     1     - 30.* NS3N - 60.* DVN) / 120.
      USN = (10.* SIN + 2.* NS35N + 3.* NS24N + 5.* NS15N + 10.* NS8N
     1     + 30.* NS3N - 60.* UVN) / 120.
      CHN = (UVN + DVN + 2*USN + 2*DSN + 2*SSN - NS15N)/6.
      BON = (UVN + DVN + 2*USN + 2*DSN + 2*SSN + 2*CHN - NS24N)/8.
      
      if (nf.eq.3) then        !GRV
         SSN= (20.* SIN - 20.* NS8N)/120.
         DSN = (20.* SIN + 10.* NS8N - 30.* NS3N - 60.* DVN) / 120.
         USN = (20.* SIN + 10.* NS8N + 30.* NS3N - 60.* UVN) / 120.
         CHN=DCMPLX(0D0,0D0)
         BON=DCMPLX(0D0,0D0)
      endif


c     INCLUDE HERE THE CORRESPONDING COEFFICIENTS C1 AND H1



c   This is alpha_S(b0^2/b^2)

       alpn=alp*4*pi


       C1qg=1d0/(N(KP,K1)**2+3d0*N(KP,K1)+2d0) 


       C1qq=2*pi**2/3d0-16/3d0+4/3d0/(N(KP,K1)*(N(KP,K1)+1))
       H1q=0d0


       if(flag1.eq.0) then 

       Hgg=0d0
       Hqg=0d0
       Hqqb=1d0
       Hqqp=0d0
       Hqq=0d0

       elseif(flag1.eq.1) then 



c Full hard coefficient: expand C*H*C at order alpha_s.
c Add renorm. scale dep terms due to the fact that
c the LO x-section begins at order alphas^2

       beta0=(33-2*nf)/12d0
       beta1=(153-19*nf)/24d0 



       Hgg=0d0
       Hqg=as/2d0*aexp*C1qg
       Hqqb=1d0+as/2d0*(H1q+2d0*C1qq)
       Hqqp=0d0
       Hqq=0d0


      if(muf2.ne.q2.or.a_param.ne.1) then 

      A1q=4d0/3d0
      B1q=-2d0

c      call ancalc(QQIN, QGFN, GQIN, GGIN, GGFN, NS1MIN, NS1PIN, NS1FN,
c     /     QQ1FN, QG1FN, GQ1IN, GQ1FN, GG1IN, GG1FN, N(KP,K1))

      gamma1qq=-1d0*(QQIM(KP,K1)/4d0)
      gamma1qg=-1d0*(QGFM(KP,K1)/8d0)
      gamma1gq=-1d0*(GQIM(KP,K1)/4d0)
      gamma1gg=-1d0*((GGIM(KP,K1)+nf*GGFM(KP,K1))/4d0)
            


      Hqqb=Hqqb-as*gamma1qq*(log(muf2/q2)+2d0*log(a_param))
      Hqqb=Hqqb + as/2d0*(-4*log(a_param))*(B1q+A1q*log(a_param))
      Hqg=Hqg-as/2d0*gamma1qg*(log(muf2/q2)+2d0*log(a_param))

      endif





c NEW: INCLUSION OF H2

       elseif(flag1.eq.2) then 


       H1stqg = C1qg 
       H1stqqb =(H1q+2d0*C1qq)

       A1q=4d0/3d0
       B1q=-2d0
       CF=4d0/3
       A2q=Cf/2d0*(67/6d0-(pi**2)/2d0-5/9d0*nf)
       B2q=-421d0/36+35d0*pi**2/27+2d0*zeta3/3
       beta0=(33-2*nf)/12d0
       beta1=(153-19*nf)/24d0 
            



!      H2 coefficients

       H2stgg = C1qg**2
       H2stqg = C2qgM(KP,K1)+ C1qq*C1qg
       H2stqqb = (2d0*C2NSqqM(KP,K1) + 2d0*C2SqqbM(KP,K1)) + C1qq**2
       H2stqq = C2NSqqbM(KP,K1) + C2SqqbM(KP,K1)
       H2stqqp = C2SqqbM(KP,K1)





      loga=log(a_param)

c      call ancalc(QQIN, QGFN, GQIN, GGIN, GGFN, NS1MIN, NS1PIN, NS1FN,
c     /     QQ1FN, QG1FN, GQ1IN, GQ1FN, GG1IN, GG1FN, N(KP,K1))

      gamma1qq=-1d0*(QQIM(KP,K1)/4d0)
      gamma1qg=-1d0*(QGFM(KP,K1)/8d0)
      gamma1gq=-1d0*(GQIM(KP,K1)/4d0)
      gamma1gg=-1d0*((GGIM(KP,K1)+nf*GGFM(KP,K1))/4d0)
!
      gamma2qg=-1d0*(QG1FM(KP,K1)/16d0)
      gamma2gq=-1d0*((GQ1IM(KP,K1)+nf*GQ1FM(KP,K1))/8d0)
      gamma2gg=-1d0*((GG1IM(KP,K1)+nf*GG1FM(KP,K1))/8d0)
!
      gamma2qqV=-1d0*((NS1PIM(KP,K1)+2*nf*NS1FM(KP,K1)
     #          +NS1MIM(KP,K1)))/16d0
      gamma2qqbV=-1d0*(NS1PIM(KP,K1)-NS1MIM(KP,K1))/16d0
      gamma2qqS=-1d0*QQ1FM(KP,K1)/16d0
      gamma2qqbS=gamma2qqS


c    Scales dependence: muF and Q

      if(muf2.ne.q2.or.a_param.ne.1) then  


       H1stqqb=H1stqqb + (-4*log(a_param))*(B1q+A1q*log(a_param))
     / -2d0*gamma1qq*(log(muf2/q2)+2d0*log(a_param))
       H1stqg=H1stqg - gamma1qg*(log(muf2/q2)+2d0*log(a_param))


      H2stqqb=H2stqqb+4d0*( (A1q/6d0*beta0*8d0*log(a_param)**3
     / +2d0*log(a_param)**2*(A2q+beta0*(-(B1q+2d0*A1q*log(a_param)+
     / gamma1qq))) 
     / -2d0*log(a_param)*(B2q+2d0*A2q*log(a_param)-beta0*(C1qq)
     / +2/4d0*(gamma2qqV+gamma2qqS))  
     / +beta0/2d0*(gamma1qq)*log(q2/muf2)**2
     / +(2/4d0*(gamma2qqV+gamma2qqS))*log(q2/muf2)
     /+1/2d0*(H1stqqb+H1q+2d0*C1qq)/2d0*(gamma1qq*(log(q2/muf2)
     / -2d0*log(a_param))
     / -((B1q+A1q*log(a_param))*2d0*log(a_param)))
     /+1/2d0*(H1stqg+C1qg)/2d0*(1/2d0*gamma1gq*(log(q2/muf2)
     / -2d0*log(a_param)))
     /+1/2d0*(H1stqg+C1qg)/2d0*(1/2d0*gamma1gq*(log(q2/muf2)
     / -2d0*log(a_param))))
     /) 

      H2stqg=H2stqg+4d0*(
     / +2d0*log(a_param)**2*(beta0*(-1/2d0*gamma1qg)) 
     / -2d0*log(a_param)*(-beta0*(1/2d0*C1qg)
     / +1/4d0*(gamma2qg))  
     / +beta0/2d0*(1/2d0*gamma1qg)*log(q2/muf2)**2
     / +((1/4d0*gamma2qg))*log(q2/muf2)
     /+1/2d0*(H1stqqb+H1q+2d0*C1qq)/2d0
     /*(1/2d0*gamma1qg*(log(q2/muf2)
     / -2d0*log(a_param))
     / )
     /+1/2d0*(H1stqg+C1qg)/2d0*(1/2d0*(gamma1gg+gamma1qq)
     /*(log(q2/muf2)
     / -2d0*log(a_param))
     /-((B1q+A1q*log(a_param))*2d0*log(a_param))) 
     /)

      H2stgg=H2stgg+4d0*(
     /(H1stqg+C1qg)/2d0*(gamma1qg/2d0*(log(q2/muf2)
     /-2d0*log(a_param)))
     /)

      H2stqq=H2stqq + 4d0*(
     / -2d0*log(a_param)*(
     / +(1/4d0*(gamma2qqbV+gamma2qqbS)))
     / +(1/4d0*(gamma2qqbV+gamma2qqbS))*log(q2/muf2)
     /+1/2d0*(H1stqg+C1qg)/2d0*(1/2d0*(gamma1gq)*(log(q2/muf2)
     / -2d0*log(a_param))
     /))

      H2stqqp=H2stqqp+4d0*(
     / -2d0*log(a_param)*(
     / +((1/4d0*gamma2qqbS)))  
     / +((1/4d0*gamma2qqbS))*log(q2/muf2)
     /+1/2d0*(H1stqg+C1qg)/2d0*(1/2d0*(gamma1gq)*(log(q2/muf2)
     / -2d0*log(a_param))
     /))

      endif


c    Scales dependence: muR


       H2stqqb=H2stqqb-4d0*(beta0*log(q2/mur2)*H1stqqb/2d0)
       H2stqg=H2stqg-4d0*(beta0*log(q2/mur2)*H1stqg/2d0)


!     H coefficient up to NNLO  with exponentiated logarithms up to NNLL
    

       Hqqb = (1 + (as/2d0)*H1stqqb+ (as/2d0)**2*H2stqqb)
     /*aexpB**(as/2d0*(C1qq-2d0*pi**2/3d0+16/3d0))              !leg q
     /*aexpB**(as/2d0*(C1qq-2d0*pi**2/3d0+16/3d0))              !leg qb

       Hqg = ( (as/2d0)*H1stqg + (as/2d0)**2*H2stqg )
     /*aexp                                                     ! leg
     /*aexpB**(as/2d0*(C2qgM(KP,K1)/C1qg-2d0*pi**2/3d0+16/3d0)) !   g
     /*aexpB**(as/2d0*(C1qq-2d0*pi**2/3d0+16/3d0))              !leg q

       Hqq = ( (as/2d0)**2*H2stqq )
     /*aexpB**(as/2d0*(C1qq-2d0*pi**2/3d0+16/3d0))              !leg q
     /*(aexp)**2                                                !leg qb prime


       Hqqp= (as/2d0)**2*H2stqqp       
     /*aexpB**(as/2d0*(C1qq-2d0*pi**2/3d0+16/3d0))              !leg q
     /*(aexp)**2                                                !leg q prime


       Hgg= (as/2d0)**2*H2stgg
     /*aexp                                                     ! leg
     /*aexpB**(as/2d0*(C2qgM(KP,K1)/C1qg-2d0*pi**2/3d0+16/3d0)) !    g
     /*aexp                                                     !  leg
     /*aexpB**(as/2d0*(C2qgM(KP,K1)/C1qg-2d0*pi**2/3d0+16/3d0)) !    g

       
      endif




c     NEW: Correct luminosities

c h1=proton
      FX1(0)=GLN
      FX1(1)=UVN+USN
      FX1(2)=DVN+DSN
      FX1(3)=SSN
      IF(NF.GE.4) FX1(4)=CHN
      IF(NF.GE.5) FX1(5)=BON
      FX1(-1)=USN
      FX1(-2)=DSN
      FX1(-3)=SSN
      IF(NF.GE.4) FX1(-4)=CHN
      IF(NF.GE.5) FX1(-5)=BON
c
      if(ippbar.eq.1) then
c h2=proton
       FX2(0)=GLN
       FX2(1)=UVN+USN
       FX2(2)=DVN+DSN
       FX2(3)=SSN
       IF(NF.GE.4) FX2(4)=CHN
       IF(NF.GE.5) FX2(5)=BON
       FX2(-1)=USN
       FX2(-2)=DSN
       FX2(-3)=SSN
       IF(NF.GE.4) FX2(-4)=CHN
       IF(NF.GE.5) FX2(-5)=BON
      elseif(ippbar.eq.-1) then
c h2=antiproton
       FX2(0)=GLN
       FX2(-1)=UVN+USN
       FX2(-2)=DVN+DSN
       FX2(-3)=SSN
       IF(NF.GE.4) FX2(-4)=CHN
       IF(NF.GE.5) FX2(-5)=BON
       FX2(1)=USN
       FX2(2)=DSN
       FX2(3)=SSN
       IF(NF.GE.4) FX2(4)=CHN
       IF(NF.GE.5) FX2(5)=BON
      endif 


!
!      FX1(0)=DCMPLX(0D0,0D0)
!      FX1(1)=UVN+USN
!      FX1(2)=DVN+DSN
!      FX1(3)=SSN
!      IF(NF.GE.4) FX1(4)=CHN
!      IF(NF.GE.5) FX1(5)=BON
!      FX1(-1)=USN
!      FX1(-2)=DSN
!      FX1(-3)=SSN
!      IF(NF.GE.4) FX1(-4)=CHN
!      IF(NF.GE.5) FX1(-5)=BON
!
!       FX2(0)=GLN
!       FX2(1)=DCMPLX(0D0,0D0)
!       FX2(2)=DCMPLX(0D0,0D0)
!       FX2(3)=DCMPLX(0D0,0D0)
!       IF(NF.GE.4) FX2(4)=DCMPLX(0D0,0D0)
!       IF(NF.GE.5) FX2(5)=DCMPLX(0D0,0D0)
!       FX2(-1)=DCMPLX(0D0,0D0)
!       FX2(-2)=DCMPLX(0D0,0D0) 
!       FX2(-3)=DCMPLX(0D0,0D0) 
!       IF(NF.GE.4) FX2(-4)=DCMPLX(0D0,0D0)
!       IF(NF.GE.5) FX2(-5)=DCMPLX(0D0,0D0)
!
      

         if (flagch.eq.1) then 
         Hgg=0d0
         Hqg=0d0
         elseif (flagch.eq.11) then
         Hgg=0d0
         Hqg=0d0
         Hqq=0d0
         Hqqp=0d0
         elseif (flagch.eq.12) then
         Hgg=0d0
         Hqg=0d0
         Hqqb=0d0
         elseif (flagch.eq.2) then
         Hgg=0d0
         Hqqb=0d0
         Hqq=0d0
         Hqqp=0d0
         elseif (flagch.eq.3) then
         Hqg=0d0
         Hqqb=0d0
         Hqq=0d0
         Hqqp=0d0
         endif


       GGN1=0
       QGN1=0
       GQN1=0
       QQBN1=0

      do si=-nf,nf
      do sj=-nf,nf
       GGN1 = GGN1+FX1(0)*FX2(0)*sigmaij(si,sj)*Hgg
       QGN1 = QGN1 +
     /    (FX1(si)*FX2(0)+FX1(0)*FX2(sj))*sigmaij(si,sj)*Hqg
       QQBN1 = QQBN1 +  FX1(si)*FX2(sj)*sigmaij(si,sj)*Hqqb
       QQBN1 = QQBN1 + (FX1(si)*FX2(-sj)+FX1(-si)*FX2(sj))
     / *sigmaij(si,sj)*Hqq
       do sk=-nf,nf
          if(sk.ne.si.and.sk.ne.-si.and.sk.ne.0) then 
          QQBN1 = QQBN1 + FX1(sk)*FX2(sj)*sigmaij(si,sj)*Hqqp
          endif
       enddo
       do sk=-nf,nf
          if(sk.ne.sj.and.sk.ne.-sj.and.sk.ne.0) then 
          QQBN1 = QQBN1 + FX1(si)*FX2(sk)*sigmaij(si,sj)*Hqqp
          endif
       enddo
       enddo
       enddo

!         if (flagch.eq.0) then 
!         QQBARN= QQBN1 + QGN1 + GGN1
!         elseif (flagch.eq.1) then
!         QQBARN= QQBN1 
!         elseif (flagch.eq.2) then
!         QQBARN=  QGN1
!         elseif (flagch.eq.3) then
!         QQBARN=  GGN1
!         else 
!         QQBARN= QQBN1 + QGN1 + GGN1
!         endif

         QQBARN= QQBN1 + QGN1 + GGN1


*...  OUTPUT
      FN(KP,KK1+1,1) = UVN
      FN(KP,KK1+1,2) = DVN
      FN(KP,KK1+1,3) = USN
      FN(KP,KK1+1,4) = DSN
      FN(KP,KK1+1,5) = SSN
      FN(KP,KK1+1,6) = GLN
      FN(KP,KK1+1,7) = QQBARN
      FN(KP,KK1+1,8) = QGN
      FN(KP,KK1+1,9) = GGN
    
  
 1    CONTINUE


      RETURN
      END
      
*     
*...Moments of NLO-input distributions
*     
      
      SUBROUTINE INP200
      implicit COMPLEX*16 (A - Z)            
      dimension UV(2,136), DV(2,136),US(2,136),DS(2,136),GL(2,136),
     1     SS(2,136), CH(2,136), BO(2,136), N(2,136)
      INTEGER K1,nnf, KP
      common/nf/nnF
      common / MOMS / N
      common / INPUT  / UV, DV, US, DS, SS, CH, BO, GL
      save / INPUT /
      
      DO 1 KP=1,2
         DO 1 K1 = 1, 136
            XN = N(KP,K1)
C     Notacion
C     la transformada de  x^a (1-x)^b  (*x^(n-1)) es
C     Gamma[1+b] Gamma[a+n]/ Gamma[1+a+b+n] =  BETA(a+n ,1+b)
C     aqui va la transformada de f(x) (y no x*f(x))
c     el programa devuelve x*f(x) 
            call F0MOMENTS(XN,UVi,DVi,USi,DSi,SSi,GLi,CHi,BOi) 
            UV(KP,K1)=UVI
            DV(KP,K1)=DVI
            US(KP,K1)=USI
            DS(KP,K1)=DSI
            SS(KP,K1)=SSI
            GL(KP,K1)=GLI
            CH(KP,K1)=CHI
            BO(KP,K1)=BOI
            if (nnf.eq.3) then  !GRV
               CH(KP,K1)=DCMPLX(0D0,0D0)
               BO(KP,K1)=DCMPLX(0D0,0D0)
            endif
            
 1       CONTINUE     
         RETURN
         END
      
*     
*...  Anomalous dimensions for leading and next to leading order
*     evolution of parton densities and Wilson coefficients for NLO 
*     structure functions.
*     The moments are calculated on an externally given array of mellin 
*     moments, N, suitable for a (non-adaptive) quadrature.
*     
*     
      SUBROUTINE ANOM (ANS, AM, AP, AL, BE, AB, AC, RMIN, RPLUS, 
     1     RMMQQ, RMMQG, RMMGQ, RMMGG, RMPQQ, RMPQG, RMPGQ, RMPGG, 
     2     RPMQQ, RPMQG, RPMGQ, RPMGG, RPPQQ, RPPQG, RPPGQ, RPPGG, 
     1     C1Q, C1G, C3Q,
C
C    ADDED
C
     #      QQIM,QGFM,GQIM,GGIM,GGFM,NS1MIM,NS1PIM,NS1FM,
     #      QQ1FM,QG1FM,GQ1IM,GQ1FM,GG1IM,GG1FM,N)
      implicit COMPLEX*16 (A - Z)
      dimension ANS(2,136), AM(2,136), AP(2,136), AL(2,136),
     1     BE(2,136), AB(2,136), AC(2,136), RMIN(2,136), 
     2     RPLUS(2,136), N(2,136), C1Q(2,136), C1G(2,136), C3Q(2,136), 
     3     RMMQQ(2,136),RMMQG(2,136),RMMGQ(2,136),RMMGG(2,136),
     4     RMPQQ(2,136),RMPQG(2,136),RMPGQ(2,136),RMPGG(2,136),
     5     RPMQQ(2,136),RPMQG(2,136),RPMGQ(2,136),RPMGG(2,136),
     6     RPPQQ(2,136),RPPQG(2,136),RPPGQ(2,136),RPPGG(2,136)

C    ADDED

           dimension QQIM(2,136),QGFM(2,136),GQIM(2,136),GGIM(2,136),
     #      GGFM(2,136),NS1MIM(2,136),NS1PIM(2,136),NS1FM(2,136),
     #      QQ1FM(2,136),QG1FM(2,136),GQ1IM(2,136),GQ1FM(2,136),
     #      GG1IM(2,136),GG1FM(2,136)

C

      REAL*8 B0, B1, B0F
      INTEGER F, FR, K1, K2, KP
      common/nf/F

      DO 1 KP=1,2
         DO 1 K1 = 1, 136
            XN = N(KP,K1)
            CALL ANCALC (QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     1           QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F, XN)
C
C
            QQIM(KP,K1)=QQI
            QGFM(KP,K1)=QGF
            GQIM(KP,K1)=GQI
            GGIM(KP,K1)=GGI
            GGFM(KP,K1)=GGF
            NS1MIM(KP,K1)=NS1MI
            NS1PIM(KP,K1)=NS1PI
            NS1FM(KP,K1)=NS1F
            QQ1FM(KP,K1)=QQ1F
            QG1FM(KP,K1)=QG1F
            GQ1IM(KP,K1)=GQ1I
            GQ1FM(KP,K1)=GQ1F
            GG1IM(KP,K1)=GG1I
            GG1FM(KP,K1)=GG1F
C
            FR = 5
*...  ANOMALOUS DIMENSIONS AND RELATED QUANTITIES IN LEADING ORDER :
            B0 = 11.- 2./3.* FR
            B0F = 11.- 2./3.* F
            B02 = 2.* B0
            B02F = 2.* B0F
            QQ = QQI
            QG = F * QGF
            GQ = GQI
            GG = GGI + F * GGF
            SQ = CDSQRT ((GG - QQ) * (GG - QQ) + 4.* QG * GQ)
            GP = 0.5 * (QQ + GG + SQ)
            GM = 0.5 * (QQ + GG - SQ)
            XANS = QQ / B02
            XAM = GM / B02
            XAP = GP / B02
            XAL = (QQ - GP) / (GM - GP)
            XBE = QG / (GM - GP)
            XAB = GQ / (GM - GP)
            XAC = 1.- XAL
            ANS(KP,K1) = XANS
            AM(KP,K1) = XAM
            AP(KP,K1) = XAP
            AL(KP,K1) = XAL
            BE(KP,K1) = XBE
            AB(KP,K1) = XAB
            AC(KP,K1) = XAC
*...  NEXT TO LEADING ORDER : ANOMALOUS DIMENSIONS IN THE MS-BAR 
*     FACTORIZATION SCHEME OF BARDEEN ET AL. (1981) :
            NS1M = NS1MI + F * NS1F
            NS1P = NS1PI + F * NS1F
            QQ1 = NS1P + F * QQ1F
            QG1 = F * QG1F
            GQ1 = GQ1I + F * GQ1F
            GG1 = GG1I + F * GG1F
*...  COMBINATIONS OF ANOMALOUS DIMENSIONS FOR NLO - SINGLET EVOLUTION :
            B1 = 102 - 38./3.* FR
            B10 = B1 / B0
            RMIN(KP,K1) = (NS1M - QQ * B10) / B02
            RPLUS(KP,K1) = (NS1P - QQ * B10) / B02
            RQQ = (QQ1 - QQ * B10) / B02
            RQG = (QG1 - QG * B10) / B02
            RGQ = (GQ1 - GQ * B10) / B02
            RGG = (GG1 - GG * B10) / B02
            NMP = 1.- XAM + XAP
            NPM = 1.- XAP + XAM
            DMQQ =  XAL * RQQ + XBE * RGQ
            DMQG =  XAL * RQG + XBE * RGG
            DMGQ =  XAB * RQQ + XAC * RGQ
            DMGG =  XAB * RQG + XAC * RGG
            DPQQ =  XAC * RQQ - XBE * RGQ
            DPQG =  XAC * RQG - XBE * RGG
            DPGQ = -XAB * RQQ + XAL * RGQ
            DPGG = -XAB * RQG + XAL * RGG
            RMMQQ(KP,K1) =   XAL * DMQQ + XAB * DMQG
            RMMQG(KP,K1) =   XBE * DMQQ + XAC * DMQG
            RMMGQ(KP,K1) =   XAL * DMGQ + XAB * DMGG
            RMMGG(KP,K1) =   XBE * DMGQ + XAC * DMGG
            RMPQQ(KP,K1) =  (XAC * DMQQ - XAB * DMQG) / NMP
            RMPQG(KP,K1) = (-XBE * DMQQ + XAL * DMQG) / NMP
            RMPGQ(KP,K1) =  (XAC * DMGQ - XAB * DMGG) / NMP
            RMPGG(KP,K1) = (-XBE * DMGQ + XAL * DMGG) / NMP
            RPMQQ(KP,K1) =  (XAL * DPQQ + XAB * DPQG) / NPM
            RPMQG(KP,K1) =  (XBE * DPQQ + XAC * DPQG) / NPM
            RPMGQ(KP,K1) =  (XAL * DPGQ + XAB * DPGG) / NPM
            RPMGG(KP,K1) =  (XBE * DPGQ + XAC * DPGG) / NPM
            RPPQQ(KP,K1) =   XAC * DPQQ - XAB * DPQG
            RPPQG(KP,K1) =  -XBE * DPQQ + XAL * DPQG
            RPPGQ(KP,K1) =   XAC * DPGQ - XAB * DPGG
            RPPGG(KP,K1) =  -XBE * DPGQ + XAL * DPGG
 2          CONTINUE
 1          CONTINUE
            RETURN
            END
*     
*...  CALCULATION OF ANOMALOUS DIMENSIONS AND WILSON COEFFICIENTS
*     UP TO THEIR DEPENDENCE OF THE NUMBER OF ACTIVE FLAVOURS F :
*     
      SUBROUTINE ANCALC (QQI, QGF, GQI, GGI, GGF, NS1MI, NS1PI, NS1F,
     1     QQ1F, QG1F, GQ1I, GQ1F, GG1I, GG1F,  XN)
      implicit COMPLEX*16 (A - Z)
      REAL*8 ZETA2, ZETA3
      XNS = XN * XN
      XN1 = XN + 1.
      XN2 = XN + 2.
      XNM = XN - 1.
C...  LEADING ORDER :
      CPSI = PSIFN (XN1) + 0.577216
      QQI = (8./3.) * (-3.- 2./(XN * XN1) + 4.* CPSI)
      QGF = -4.* (XNS + XN +2.) / (XN * XN1 * XN2)
      GQI = -(16./3.) * (XNS + XN + 2.) / (XN * XN1 * XNM)
      GGI = -22.- 24./(XN * XNM) - 24./(XN1 * XN2) + 24.* CPSI
      GGF = 4./3.
C...  NEXT TO LEADING ORDER :
      XNT = XNS * XN
      XNFO = XNT * XN
      XN1S = XN1 * XN1
      XN1T = XN1S * XN1
C...  ANALYTIC CONTINUATIONS OF N-SUMS AS GIVEN IN GLUECK ET AL. (1990) :
      ZETA2 = 1.644934
      ZETA3 = 1.202057
      CPSI1 = ZETA2 - PSIFN1 (XN1)
      CPSI2 = 0.5 * PSIFN2 (XN1) - ZETA2
      SPMOM = 1.01/XN1 - 0.846/XN2 + 1.155/(XN+3.) - 1.074/(XN+4.) +
     1     0.55/(XN+5.)
      SLC = -5./8.* ZETA3
      SLV = - ZETA2/2.* (PSIFN (XN1/2.) - PSIFN (XN/2.))
     1     + CPSI/XNS + SPMOM
      SSCHLM = SLC - SLV
      SSTR2M = ZETA2 - PSIFN1 (XN1/2.)
      SSTR3M = 0.5 * PSIFN2 (XN1/2.) + ZETA3
      SSCHLP = SLC + SLV
      SSTR2P = ZETA2 - PSIFN1 (XN2/2.)
      SSTR3P = 0.5 * PSIFN2 (XN2/2.) + ZETA3
C...  NON-SINGLET PIECES AS GIVEN IN CURCI ET AL. (1980) :
      NS1MA = 16.* CPSI * (2.* XN + 1.) / (XNS * XN1S) +
     1     16.* (2.* CPSI - 1./(XN * XN1)) * ( CPSI1 - SSTR2M ) +
     2     64.* SSCHLM + 24.* CPSI1 - 3. - 8.* SSTR3M -
     3     8.* (3.* XNT + XNS -1.) / (XNT * XN1T) +
     4     16.* (2.* XNS + 2.* XN +1.) / (XNT * XN1T)
      NS1PA = 16.* CPSI * (2.* XN + 1.) / (XNS * XN1S) +
     1     16.* (2.* CPSI - 1./(XN * XN1)) * ( CPSI1 - SSTR2P ) +
     2     64.* SSCHLP + 24.* CPSI1 - 3. - 8.* SSTR3P -
     3     8.* (3.* XNT + XNS -1.) / (XNT * XN1T) -
     4     16.* (2.* XNS + 2.* XN +1.) / (XNT * XN1T)
      NS1B = CPSI * (536./9. + 8.* (2.* XN + 1.) / (XNS * XN1S)) -
     1     (16.* CPSI + 52./3.- 8./(XN * XN1)) * CPSI1 - 43./6. -
     2     (151.* XNFO + 263.* XNT + 97.* XNS + 3.* XN + 9.) *
     3     4./ (9.* XNT * XN1T)
      NS1C = -160./9.* CPSI + 32./3.* CPSI1 + 4./3. +
     1     16.* (11.* XNS + 5.* XN - 3.) / (9.* XNS * XN1S)
      NS1MI = -2./9.* NS1MA + 4.* NS1B
      NS1PI = -2./9.* NS1PA + 4.* NS1B
      NS1F = 2./3. * NS1C
C...  SINGLET PIECES AS GIVEN IN FLORATOS ET AL. (1981) :
      XNFI = XNFO * XN
      XNSI = XNFI * XN
      XNSE = XNSI * XN
      XNE = XNSE * XN
      XNN = XNE * XN
      XNMS = XNM * XNM
      XN2S = XN2 * XN2
      XN2T = XN2S * XN2
      QQ1F = (5.* XNFI + 32.* XNFO + 49.* XNT + 38.* XNS + 28.* XN
     1     + 8.) / (XNM * XNT * XN1T * XN2S) * (-32./3.)
      QG1A = (-2.* CPSI * CPSI + 2.* CPSI1 - 2.* SSTR2P)
     1     * (XNS + XN + 2.) / (XN * XN1 * XN2)
     2     + (8.* CPSI * (2.* XN + 3.)) / (XN1S * XN2S)
     3     + 2.* (XNN + 6.* XNE + 15. * XNSE + 25.* XNSI + 36.* XNFI
     4     + 85.* XNFO + 128.* XNT + 104.* XNS + 64.* XN + 16.)
     5     / (XNM * XNT * XN1T * XN2T)
      QG1B = (2.* CPSI * CPSI - 2.* CPSI1 + 5.) * (XNS + XN + 2.)
     1     / (XN * XN1 * XN2)   -   4.* CPSI / XNS
     2     + (11.* XNFO + 26.* XNT + 15.* XNS + 8.* XN + 4.)
     3     / (XNT * XN1T * XN2)
      QG1F = - 12.* QG1A - 16./3.* QG1B
      GQ1A = (-2.* CPSI * CPSI + 10.* CPSI - 2.* CPSI1)
     1     * (XNS + XN + 2.) / (XNM * XN * XN1)  -  4.* CPSI / XN1S
     2     - (12.* XNSI + 30.* XNFI + 43.* XNFO + 28.* XNT - XNS
     3     - 12.* XN - 4.) / (XNM * XNT * XN1T)
      GQ1B = (CPSI * CPSI + CPSI1 - SSTR2P) * (XNS + XN + 2.)
     1     / (XNM * XN * XN1)
     2     - CPSI * (17.* XNFO + 41.* XNS - 22.* XN - 12.)
     3     / (3.* XNMS * XNS * XN1)
     4     + (109.* XNN + 621.* XNE + 1400.* XNSE + 1678.* XNSI
     5     + 695.* XNFI - 1031.* XNFO - 1304.* XNT - 152.* XNS
     6     + 432.* XN + 144.) / (9.* XNMS * XNT * XN1T * XN2S)
      GQ1C = (CPSI - 8./3.) * (XNS + XN + 2.) / (XNM * XN * XN1)
     1     + 1./ XN1S
      GQ1I = - 64./9.* GQ1A - 32.* GQ1B
      GQ1F = - 64./9.* GQ1C
      GG1A = 16./9.* (38.* XNFO + 76.* XNT + 94.* XNS + 56.* XN + 12.)
     1     / (XNM * XNS * XN1S * XN2)   -   160./9.* CPSI + 32./3.
      GG1B = (2.* XNSI + 4.* XNFI + XNFO - 10.* XNT - 5.* XNS - 4.* XN
     1     - 4.) * 16. / (XNM * XNT * XN1T * XN2)   +   8.
      GG1C = (2.* XNFI + 5.* XNFO + 8.* XNT + 7.* XNS - 2.* XN - 2.)
     1     * 64.* CPSI / (XNMS * XNS * XN1S * XN2S)
     2     + 536./9.* CPSI - 64./3.
     3     + 32.* SSTR2P * (XNS + XN + 1.) / (XNM * XN * XN1 * XN2)
     4     - 16.* CPSI * SSTR2P + 32.* SSCHLP - 4.* SSTR3P
     5     - 4.* (457.* XNN + 2742.* XNE + 6040.* XNSE + 6098.* XNSI
     6     + 1567.* XNFI - 2344.* XNFO - 1632.* XNT + 560.* XNS
     7     + 1488.* XN + 576.) / (9.* XNMS * XNT * XN1T * XN2T)
      GG1I = 9.* GG1C
      GG1F = 3./2.* GG1A + 2./3.* GG1B
      
      RETURN
      END
*     
*     
*...  Initialization of support points in n-space and weights for the 
*     Gauss quadrature and of the anomalous dimensions for the RG 
*     evolution at these n-values. The outputs are written into the 
*     common-blocks CONT, MOMS, WEIGHTS and ANOMS, respectively. 
*     
      SUBROUTINE INIT
      implicit double precision (A - Z)
      INTEGER I1, I2, I3, K
      dimension ZS(8), WZ(8), DOWN(17), UP(17), WN(136)
      COMPLEX*16 ANS(2,136), AM(2,136), AP(2,136), AL(2,136),
     1     BE(2,136), AB(2,136), AC(2,136), RMIN(2,136),
     2     RPLUS(2,136), N(2,136), C1Q(2,136), C1G(2,136), C3Q(2,136),
     3     RMMQQ(2,136),RMMQG(2,136),RMMGQ(2,136),RMMGG(2,136),
     4     RMPQQ(2,136),RMPQG(2,136),RMPGQ(2,136),RMPGG(2,136),
     5     RPMQQ(2,136),RPMQG(2,136),RPMGQ(2,136),RPMGG(2,136),
     6     RPPQQ(2,136),RPPQG(2,136),RPPGQ(2,136),RPPGG(2,136),
     7     CC(2)
C ADDED
      complex*16 QQIM(2,136),QGFM(2,136),GQIM(2,136),GGIM(2,136),
     #      GGFM(2,136),NS1MIM(2,136),NS1PIM(2,136),NS1FM(2,136),
     #      QQ1FM(2,136),QG1FM(2,136),GQ1IM(2,136),GQ1FM(2,136),
     #      GG1IM(2,136),GG1FM(2,136)
C
      common/anomdim/QQIM,QGFM,GQIM,GGIM,GGFM,NS1MIM,NS1PIM,NS1FM,
     #      QQ1FM,QG1FM,GQ1IM,GQ1FM,GG1IM,GG1FM
C      
      common / WEIGHTS / WN
      common / MOMS / N
      common / CONTin / C, CC
      common / ANOMS / ANS, AM, AP, AL, BE, AB, AC, RMIN, RPLUS, C1Q,
     1     C1G, C3Q, RMMQQ, RMMQG, RMMGQ, RMMGG, RMPQQ, RMPQG, RMPGQ,
     2     RMPGG, RPMQQ, RPMQG, RPMGQ, RPMGG, RPPQQ, RPPQG, RPPGQ,
     3     RPPGG
C ADDED
      complex*16 C2qgM(2,136),C2NSqqbM(2,136),
     #          C2NSqqM(2,136),C2SqqbM(2,136)
      common / H2mat / C2qgM,C2NSqqbM,C2NSqqM,C2SqqbM
C
      save / WEIGHTS /
      save / MOMS /
      save / CONTin /
      save / ANOMS /
      save / H2mat /

*...  WEIGHTS AND SUPPORT POINTS FOR NOMALIZED 8 POINT GAUSS QUADRATURE :
      data WZ
     1     / 0.10122 85362 90376,  0.22238 10344 53374, 
     2     0.31370 66458 77887,  0.36268 37833 78362, 
     3     0.36268 37833 78362,  0.31370 66458 77887,
     4     0.22238 10344 53374,  0.10122 85362 90376/
      data ZS
     1     /-0.96028 98564 97536, -0.79666 64774 13627, 
     2     -0.52553 24099 16329, -0.18343 46424 95650, 
     3     0.18343 46424 95650,  0.52553 24099 16329,
     4     0.79666 64774 13627,  0.96028 98564 97536/
*...  INTEGRATION CONTOUR PARAMETERS :
      data DOWN / 0.D0, 0.5D0, 1.D0, 2.D0, 3.D0, 4.D0, 6.D0, 8.D0,
     1     1.D1, 1.2D1, 1.5D1, 1.8D1, 2.1D1, 2.4D1, 2.7D1, 3.D1, 3.3D1/
      
! Modifica Massimiliano  19/12/07
!      C = 1.8
      C=1.0
      
      PHI = 3.141592654 * 3./4.
      CO = DCOS (PHI)
      SI = DSIN (PHI)
      CC(1) = DCMPLX (CO, SI)
      CC(2) = DCMPLX (CO,-SI)
      DO 1 I1 = 1, 16
         UP(I1) = DOWN(I1+1)
 1    CONTINUE
      UP(17) = 36.D0 
*...  SUPPORT POINTS AND WEIGHTS FOR THE GAUSS INTEGRATION : 
*     (THE FACTOR (UP-DOWN)/2 IS INCLUDED IN THE WEIGHTS)
      K = 0
      DO 2 I2 = 1, 17
         SUM  = UP(I2) + DOWN(I2) 
         DIFF = UP(I2) - DOWN(I2) 
         DO 3 I3 = 1, 8
            K = K + 1
            Z = 0.5 * (SUM + DIFF * ZS(I3))
            WN(K) = DIFF / 2.* WZ(I3) 
            N(1,K)  = DCMPLX (C+CO*Z+1.,SI*Z)
            N(2,K)  = DCMPLX (C+CO*Z+1.,-SI*Z)
            
 3       CONTINUE
 2    CONTINUE 
      CALL ANOM (ANS, AM, AP, AL, BE, AB, AC, RMIN, RPLUS,
     1     RMMQQ, RMMQG, RMMGQ, RMMGG, RMPQQ, RMPQG, RMPGQ, RMPGG,
     2     RPMQQ, RPMQG, RPMGQ, RPMGG, RPPQQ, RPPQG, RPPGQ, RPPGG,
     3     C1Q, C1G, C3Q,
     #     QQIM,QGFM,GQIM,GGIM,GGFM,NS1MIM,NS1PIM,NS1FM,
     #     QQ1FM,QG1FM,GQ1IM,GQ1FM,GG1IM,GG1FM,N)


C    ADDED
C
      call H2matrix(C2qgM,C2NSqqbM,C2NSqqM,C2SqqbM,N)
c      write(*,*)C2qgM(1,13),C2NSqqbM(1,13),C2NSqqM(1,13),
c     #        C2SqqbM(1,13),N(1,13)
C
C
      RETURN
      END 
      
      
C     Computes the moments of L^(0)
      SUBROUTINE F0MOMENTS(N,UV,DV,US,DS,SS,GL,CH,BO)
      implicit COMPLEX*16 (A-Z)
      double precision A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      double precision A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      double precision A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US 
      double precision A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      double precision A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      double precision A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      double precision A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      double precision A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      double precision GE,ZETA2,ZETA3,PI,aa 
      common/ CUV/ A1UV,A2UV,A3UV,A4UV,A5UV,A6UV,A7UV,A8UV
      common/ CDV/ A1DV,A2DV,A3DV,A4DV,A5DV,A6DV,A7DV,A8DV
      common/ CUS/ A1US,A2US,A3US,A4US,A5US,A6US,A7US,A8US
      common/ CDS/ A1DS,A2DS,A3DS,A4DS,A5DS,A6DS,A7DS,A8DS
      common/ CSS/ A1SS,A2SS,A3SS,A4SS,A5SS,A6SS,A7SS,A8SS
      common/ CGL/ A1GL,A2GL,A3GL,A4GL,A5GL,A6GL,A7GL,A8GL
      common/ CCH/ A1CH,A2CH,A3CH,A4CH,A5CH,A6CH,A7CH,A8CH
      common/ CBO/ A1BO,A2BO,A3BO,A4BO,A5BO,A6BO,A7BO,A8BO
      common/exp/aa
      data GE/ 0.577216d0 /
      data ZETA2/1.64493d0 / 
      data ZETA3/1.20206d0 /
      data PI/3.1415926536d0 /
      AAA=DCMPLX(aa,0.d0)
C     U-VALENCE
      CA1=DCMPLX(A1UV,0.d0)
      CA2=DCMPLX(A2UV,0.d0)
      CA3=DCMPLX(A3UV,0.d0)
      CA4=DCMPLX(A4UV,0.d0)
      CA5=DCMPLX(A5UV,0.d0)
      CA6=DCMPLX(A6UV,0.d0)
      CA7=DCMPLX(A7UV,0.d0)
      CA8=DCMPLX(A8UV,0.d0)
      UV=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-VALENCE
      CA1=DCMPLX(A1DV,0.d0)
      CA2=DCMPLX(A2DV,0.d0)
      CA3=DCMPLX(A3DV,0.d0)
      CA4=DCMPLX(A4DV,0.d0)
      CA5=DCMPLX(A5DV,0.d0)
      CA6=DCMPLX(A6DV,0.d0)
      CA7=DCMPLX(A7DV,0.d0)
      CA8=DCMPLX(A8DV,0.d0)
      DV=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     U-BAR
      CA1=DCMPLX(A1US,0.d0)
      CA2=DCMPLX(A2US,0.d0)
      CA3=DCMPLX(A3US,0.d0)
      CA4=DCMPLX(A4US,0.d0)
      CA5=DCMPLX(A5US,0.d0)
      CA6=DCMPLX(A6US,0.d0)
      CA7=DCMPLX(A7US,0.d0)
      CA8=DCMPLX(A8US,0.d0)
      US=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     D-BAR
      CA1=DCMPLX(A1DS,0.d0)
      CA2=DCMPLX(A2DS,0.d0)
      CA3=DCMPLX(A3DS,0.d0)
      CA4=DCMPLX(A4DS,0.d0)
      CA5=DCMPLX(A5DS,0.d0)
      CA6=DCMPLX(A6DS,0.d0)
      CA7=DCMPLX(A7DS,0.d0)
      CA8=DCMPLX(A8DS,0.d0)
      DS=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1) 
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     S-BAR
      CA1=DCMPLX(A1SS,0.d0)
      CA2=DCMPLX(A2SS,0.d0)
      CA3=DCMPLX(A3SS,0.d0)
      CA4=DCMPLX(A4SS,0.d0)
      CA5=DCMPLX(A5SS,0.d0)
      CA6=DCMPLX(A6SS,0.d0)
      CA7=DCMPLX(A7SS,0.d0)
      CA8=DCMPLX(A8SS,0.d0)
      SS=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     GLUON
      CA1=DCMPLX(A1GL,0.d0)
      CA2=DCMPLX(A2GL,0.d0)
      CA3=DCMPLX(A3GL,0.d0)
      CA4=DCMPLX(A4GL,0.d0)
      CA5=DCMPLX(A5GL,0.d0)
      CA6=DCMPLX(A6GL,0.d0)
      CA7=DCMPLX(A7GL,0.d0)
      CA8=DCMPLX(A8GL,0.d0)
      GL=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     CHARM
      CA1=DCMPLX(A1CH,0.d0)
      CA2=DCMPLX(A2CH,0.d0)
      CA3=DCMPLX(A3CH,0.d0)
      CA4=DCMPLX(A4CH,0.d0)
      CA5=DCMPLX(A5CH,0.d0)
      CA6=DCMPLX(A6CH,0.d0)
      CA7=DCMPLX(A7CH,0.d0)
      CA8=DCMPLX(A8CH,0.d0)
      CH=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
C     BOTTOM
      CA1=DCMPLX(A1BO,0.d0)
      CA2=DCMPLX(A2BO,0.d0)
      CA3=DCMPLX(A3BO,0.d0)
      CA4=DCMPLX(A4BO,0.d0)
      CA5=DCMPLX(A5BO,0.d0)
      CA6=DCMPLX(A6BO,0.d0)
      CA7=DCMPLX(A7BO,0.d0)
      CA8=DCMPLX(A8BO,0.d0)
      BO=CA1*CBETA(CA2-1+N,CA3+1) + CA1*CA4*CBETA(CA2+N,CA3+1)+
     .     CA1*CA5*CBETA(CA2-1+0.5+N,CA3+1)
     .     + CA1*CA6*CBETA(CA2-1+1.5+N,CA3+1) 
     .     + CA1*CA7*CBETA(CA2-1+2+N,CA3+1)
     .     + CA1*CA8*CBETA(CA2-1+AAA+N,CA3+1)
      RETURN
      END               
      
      
      
      function xqq(xx)
      implicit double precision (A-H,J-Z)
      real*8 aa,uv0
c     common/x/x,Q2,Q20
      common/ippbar/ippbar
      include 'scales.h'
      z=xtau**xx
      y=xtau/z
      call distri(z,sqrt(q2),unv1,dnv1,us1,ds1,str1,chm,bot,glu1,ippbar)
      call distri(y,sqrt(q2),unv2,dnv2,us2,ds2,str2,chm,bot,glu2,ippbar)
      xqq=((unv1+us1)*us2 + (dnv1+ds1)*ds2 + str1*str2) +
     .     ((unv2+us2)*us1 + (dnv2+ds2)*ds1 + str2*str1)  
      return
      end
      
      function xqg(xx)
      implicit double precision (A-H,J-Z)
      real*8 aa,uv0
c     common/x/x,Q2,Q20
      common/ippbar/ippbar
      include 'scales.h'
      z=xtau**xx
      y=xtau/z
      q=dsqrt(q2)
      call distri(z,q,unv1,dnv1,us1,ds1,str1,chm1,bot1,glu1,ippbar)
      call distri(y,q,unv2,dnv2,us2,ds2,str2,chm2,bot2,glu2,ippbar)
      xqg=((unv1+2*us1)+(dnv1+2*ds1)+ 2*str1+0*chm1+0*bot1)*glu2 +
     .     ((unv2+2*us2)+(dnv2+2*ds2)+ 2*str2+0*chm2+0*bot2)*glu1
      return
      end
      
      function xgg(xx)
      implicit double precision (A-H,J-Z)
      real*8 aa,uv0
c     common/x/x,Q2,Q20
      common/ippbar/ippbar
      include 'scales.h'
      z=xtau**xx
      y=xtau/z
      call distri(z,sqrt(q2),unv1,dnv1,us1,ds1,str1,chm,bot,glu1,ippbar)
      call distri(y,sqrt(q2),unv2,dnv2,us2,ds2,str2,chm,bot,glu2,ippbar)
      xgg=glu1*glu2
      return
      end


C ADDED: Computes and stores matrix of C2 values

      subroutine H2matrix(C2qgM,C2NSqqbM,C2NSqqM,C2SqqbM,N)
      implicit COMPLEX*16 (A - Z)
      integer KP,K1
      dimension C2qgM(2,136),C2NSqqbM(2,136),C2NSqqM(2,136),
     #  C2SqqbM(2,136),N(2,136)
        

      do KP=1,2
      do K1=1,136
      XN=N(KP,K1)
      call H2calc(C2qg,C2NSqqb,C2NSqq,C2Sqqb,XN)
      C2qgM(KP,K1)=C2qg
      C2NSqqbM(KP,K1)=C2NSqqb
      C2NSqqM(KP,K1)=C2NSqq
      C2SqqbM(KP,K1)=C2Sqqb
      enddo
      enddo

      return
      end

C ADDED: Computes the various C2 coefficients at a given value of XN

      subroutine H2calc(C2qg,C2NSqqb,C2NSqq,C2Sqqb,XN)
      implicit complex*16 (A - Z) 
      REAL*8 zeta2,zeta3,zeta4,plog41f2,log2,pi,GE,CF,CA
      integer nf
      common/nf/nf

       zeta2=   1.64493406685d0
       zeta3=   1.20205690316d0
       zeta4=   1.08232323371d0
       plog41f2=0.5174790616738993d0
       log2=0.693147180559945d0
       pi=3.141592653589793d0

       GE   = 0.57721566490153D0
       ONE=CMPLX(1.0D0,0.0D0)
       CF=4/3d0
       CA=3d0

       XNP1= XN+ONE
       XNP2= XN+ONE+ONE
       XNP3= XN+ONE+ONE+ONE
       XNM1= XN-ONE
       XNf2P1= XN/2d0+ONE
       XNf2P2= XN/2d0+ONE+ONE
       XNf2P3f2= XN/2d0+3/2d0*ONE
       XNf2P1f2= XN/2d0+1/2d0*ONE
       XNf2= XN/2d0


!     Function needed to write the H2 coefficient in the Mellin space

      CALL PSI0(XNP1,PS0NP1)
      CALL PSI0(XNP2,PS0NP2)
      CALL PSI0(XNP3,PS0NP3)
      CALL PSI0(XN,PS0N)
      CALL PSI0(XNf2P1,PS0Nf2P1)
      CALL PSI0(XNf2P3f2,PS0Nf2P3f2)
      CALL PSI0(XNf2P1f2,PS0Nf2P1f2)
      CALL PSI0(XNf2,PS0Nf2)
      CALL PSI0(XNf2P2,PS0Nf2P2)
!
      CALL PSI1(XNP1,PS1NP1)
      CALL PSI1(XNP2,PS1NP2)
      CALL PSI1(XNP3,PS1NP3)
      CALL PSI1(XN,PS1N)
      CALL PSI1(XNf2,PS1Nf2)
      CALL PSI1(XNf2P1,PS1Nf2P1)
      CALL PSI1(XNf2P3f2,PS1Nf2P3f2)
      CALL PSI1(XNf2P1f2,PS1Nf2P1f2)
      CALL PSI1(XNf2P2,PS1Nf2P2)

!
      CALL PSI2(XNP1,PS2NP1)
      CALL PSI2(XNP2,PS2NP2)
      CALL PSI2(XNP3,PS2NP3)
      CALL PSI2(XN,PS2N)
      CALL PSI2(XNf2,PS2Nf2)
      CALL PSI2(XNf2P1,PS2Nf2P1)
      CALL PSI2(XNf2P3f2,PS2Nf2P3f2)
      CALL PSI2(XNf2P1f2,PS2Nf2P1f2)
      CALL PSI2(XNf2P2,PS2Nf2P2)
!
      CALL PSI3(XN,PS3N)
      CALL PSI3(XNf2,PS3Nf2)
      CALL PSI3(XNf2P1f2,PS3Nf2P1f2)
      CALL PSI3(XNf2,PS3Nf2)
      
      CALL BET(XN,BETA0N)
      CALL BET(XNP1,BETA0NP1)
      CALL BET(XNP2,BETA0NP2)
      CALL BET(XNP3,BETA0NP3)
      CALL BET1(XN,BETA1N)
      CALL BET2(XN,BETA2N)
      CALL BET3(XN,BETA3N)

      S1N= PS0NP1+GE        
      S1NP1= PS0NP2+GE      
      S1NP2= PS0NP3+GE
      S1NM1= PS0N+GE
      S1Nf2= PS0Nf2P1+GE
      S1NM1f2= PS0Nf2P1f2+GE
      S1NP1f2= PS0Nf2P3f2+GE
      S1NM2f2= PS0Nf2+GE
      S1NP2f2= PS0Nf2P2+GE

      S2N= -PS1NP1+zeta2
      S2NP1= -PS1NP2+zeta2  
      S2NP2= -PS1NP3+zeta2  
      S2NM1= -PS1N+zeta2    
      S2Nf2= -PS1Nf2P1+zeta2
      S2NP1f2= -PS1Nf2P3f2+zeta2
      S2NM1f2= -PS1Nf2P1f2+zeta2
      S2NP2f2= -PS1Nf2P2+zeta2

      S3N= PS2NP1/2d0+zeta3
      S3NP1= PS2NP2/2d0+zeta3
      S3NP2=  PS2NP3/2d0+zeta3
!      S2NP2= PS1NP3+zeta2
      S3NM1= PS2N/2d0+zeta3
      S3Nf2= PS2Nf2P1/2d0+zeta3
      S3NP1f2= PS2Nf2P3f2/2d0+zeta3
      S3NM1f2= PS2Nf2P1f2/2d0+zeta3
      S3NP2f2= PS2Nf2P2/2d0+zeta3


      S4NM1= -PS3N/6d0+zeta4
      S4NM1f2= -PS3Nf2P1f2/6d0+zeta4
      S4NM2f2= -PS3Nf2/6d0+zeta4
      S211NM1= -ACG21(XNM1)+6d0/5*zeta2**2
!      S112NM1=0
!      S121NM1=0

      S31NM1= ACG20(XNM1)+zeta2*S2NM1-1d0/2*zeta2**2


      Sm1NM1= (1)*BETA0N-log2
      Sm1N=   (-1)*BETA0NP1-log2
      Sm1NP1= (1)*BETA0NP2-log2
      Sm1NP2= (-1)*BETA0NP3-log2
      Sm2NM1= (-1)*BETA1N-zeta2/2d0
      Sm3NM1= (1)*BETA2N/2d0-zeta3*3/4d0
      Sm4NM1= (-1)*BETA3N/6d0-zeta4*7/8d0

      Sm21N= ACG3(XN)*(1)+zeta2*Sm1N
     /       -5/8d0*zeta3+zeta2*log2
      Sm21NP1= ACG3(XNP1)*(-1)+zeta2*Sm1NP1
     /       -5/8d0*zeta3+zeta2*log2
      Sm21NP2= ACG3(XNP2)*(1)+zeta2*Sm1NP2
     /       -5/8d0*zeta3+zeta2*log2

      Sm31NM1= ACG6(XNM1)*(1)+zeta2*Sm2NM1-zeta3*Sm1NM1
     /       -3/5d0*zeta2**2+2*plog41f2+3/4d0*zeta3*log2
     /       -zeta2/2d0*log2**2+log2**4/12d0
      Sm22NM1= ACG5(XNM1)*(1)-2d0*Sm31NM1
     /         +2d0*zeta2*Sm2NM1+3/40d0*zeta2**2
      Sm211NM1= ACG8(XNM1)*(-1)+zeta3*Sm1NM1-plog41f2+zeta2**2/8d0
     /     +zeta3*log2/8d0+zeta2*log2**2/4d0-log2**4/24d0


      ACG13XNM1 = ACG13(XNM1)
      ACG1XNM1  = ACG1(XNM1)
      ACG1pXN   = ACG1p(XN)
      ACG1pXNP1 = ACG1p(XNP1)
      ACG1ppXNM1= ACG1pp(XNM1)
      ACG2pXNM1 = ACG2p(XNM1)
      ACG4XN    = ACG4(XN)
      ACG4XNP1  = ACG4(XNP1)
      ACG4pXNM1 = ACG4p(XNM1)
      ACG5XNM1  = ACG5(XNM1)
      ACG6XNM1  = ACG6(XNM1)
      ACG7XNM1  = ACG7(XNM1)
      ACG9XNM1  = ACG9(XNM1)


!      C2 coefficient in the Mellin space

       C2Sqqb=
     / (CF*(172/XNM1-54/XN**4-27/XN**3
     / -126/XN**2-315/XN-54/XNP1**4- 27/XNP1**3+180/XNP1**2
     / +279/XNP1 -72/XNP2**3-192/XNP2**2
     / -136/XNP2-(72*zeta2)/XNM1 +(108*zeta2)/XN-
     / (108*zeta2)/XNP1+(72*zeta2)/XNP2
     / +(72*S2NM1)/XNM1 -(108*S2N)/XN
     / +(108*S2NP1)/XNP1 -(72*S2NP2)/XNP2))/432


      C2NSqq =
!
     / CF*nf*(
     / 127/192d0 -1/(24*XN**3)+5/(72*XN**2)-37/(216*XN) -1/(24*XNP1**3)
     /  +5/(72*XNP1**2)-19/(216*XNP1)-(2*zeta2)/3+(7*zeta3)/36
     /  -(7*S1NM1)/27+(5*S2NM1)/36-S3NM1/12)+
     / CA*CF*(
     / -1535/384d0-1/(8*XN**4)+11/(48*XN**3)-47/(72*XN**2)
     / +50/(27*XN)
     / - 1/(8*XNP1**4)-1/(48*XNP1**3)-83/(72*XNP1**2)+1/(54*XNP1)+
     / (97*zeta2)/24-(3*zeta2)/(8*XN)+(3*zeta2)/(8*XNP1)+(85*zeta3)/72-
     /(5*zeta3)/(8*XN)-(5*zeta3)/(8*XNP1)
     /-(29*zeta4)/16+(101*S1NM1)/54-
     /   (5*zeta3*S1NM1)/4+(zeta2*S1NM1**2)/4+(zeta2*S1N)/(4*XN)-
     /   S1NP1/(8*XNP1)+(zeta2*S1NP1)/(4*XNP1)-(19*S2NM1)/18
     /   +(zeta2*S2NM1)/4-(S1NM1**2*S2NM1)/4+S2N/(4*XN**2)+
     /   S2N/(4*XN)-(S1N*S2N)/(4*XN)+S2NP1/(4*XNP1**2)
     /   -S2NP1/(4*XNP1)-(S1NP1*S2NP1)/(4*XNP1)
     /  + S211NM1/2 +(11*S3NM1)/24-(S1NM1*S3NM1)/2
     /  - S3N/(4*XN)-S3NP1/(4*XNP1)-S4NM1/2)+
!
     / CF**2*(
     / 255/128d0-1/(8*XN**4)+3/(8*XN**2)-19/(8*XN)-1/(8*XNP1**4)+
     /   1/(4*XNP1**3)+2/XNP1**2+19/(8*XNP1)-(35*zeta2)/16
     /+(3*zeta2)/(2*XN)-(3*zeta2)/(2*XNP1)-(3*zeta3)/2-(3*zeta3)/(4*XN)-
     /  (3*zeta3)/(4*XNP1)+(61*zeta4)/16-(3*zeta3*S1NM1)/2-
     /  (zeta2*S1NM1**2)/2-S1N/(4*XN**2)
     /   -(zeta2*S1N)/(2*XN)+S1N**2/(8*XN**2)+
     /   S1NP1/(4*XNP1**2)+S1NP1/(8*XNP1)-
     /   (zeta2*S1NP1)/(2*XNP1)+S1NP1**2/(8*XNP1**2)+S2NM1
     /   -(zeta2*S2NM1)/2+(S1NM1**2*S2NM1)/2-(3*S2N)/(8*XN**2)-
     /   (3*S2N)/(4*XN)+(S1N*S2N)/(2*XN)-(3*S2NP1)/(8*XNP1**2)+
     /   (3*S2NP1)/(4*XNP1)+(S1NP1*S2NP1)/(2*XNP1)
     /  - S211NM1/2 -(3*S3NM1)/8+(3*S1NM1*S3NM1)/2+
     /   (3*S3N)/(4*XN)+(3*S3NP1)/(4*XNP1)-S31NM1/2+S4NM1)


      C2NSqqb = (-CA/2d0+CF)*CF/24d0*(
     /168d0+4d0*XN*(180d0+3*XN*(97d0+XN*(79d0+XN*(32d0+XN*(7d0+XN))))-
     /2*XN*XNP1**3*(1+2*XN)*pi**2)-XN**2*XNP1**2*
     /(192*XN**2*XNP1**2*ACG13XNM1+16*XN**2*XNP1**2*pi**2*ACG1XNM1+
     /48*(PS1Nf2-PS1N)+XN*(96*XNP1**2*ACG1pXN
     /-96*XN*XNP1*ACG1pXNP1-48*XN*ACG1ppXNM1-96*XN**2*ACG1ppXNM1
     /-48*XN**3*ACG1ppXNM1+96*XN*ACG2pXNM1+192*XN**2*ACG2pXNM1+
     /96*XN**3*ACG2pXNM1+96*ACG4XN+192*XN*ACG4XN
     /+96*XN**2*ACG4XN-96*XN*ACG4XNP1-96*XN**2*ACG4XNP1+
     /96*XN*ACG4pXNM1+192*XN**2*ACG4pXNM1+96*XN**3*ACG4pXNM1+
     /96*XN*ACG5XNM1+192*XN**2*ACG5XNM1+96*XN**3*ACG5XNM1-
     /192*XN*ACG6XNM1-384*XN**2*ACG6XNM1-192*XN**3*ACG6XNM1
     /-288*XN*ACG7XNM1-576*XN**2*ACG7XNM1-288*XN**3*ACG7XNM1
     /+192*XN*ACG9XNM1+384*XN**2*ACG9XNM1+
     /192*XN**3*ACG9XNM1-4*XN*XNP1*pi**2*PS0Nf2P3f2-
     /12*(-6+(-3+XN)*XN)*PS1Nf2+48*XN*XNP1*PS1N-
     /12*XN*(3+XN)*PS1Nf2P3f2-3*XNP1*(2+3*XN)*
     /PS2Nf2+24*XNP1**2*PS2N+
     /3*XN*XNP1*PS2Nf2P3f2-XN*XNP1**2*PS3Nf2+
     /8*XN*XNP1**2*PS3N+8*XNP1**2*log2*
     /(pi**2+6*XN*zeta3)-8*XNP1**2*PS0N*
     /(pi**2+6*XN*zeta3)
     /+4*XNP1*PS0Nf2
     /*((2+3*XN)*pi**2+12*XN*XNP1*zeta3)
     /))
     /)/(4d0*XN**4*XNP1**4)


       C2qg=
!
     /CF*(
     /1/(16*XN**4)+1/(32*XN**3)-1/(4*XN**2)-13/(32*XN)
     /-1/(8*XNP1**4)+
     /3/(8*XNP1**3)-15/(32*XNP1**2)+43/(32*XNP1)+1/(4*XNP2**4)-
     /1/(4*XNP2**3)+1/(4*XNP2**2)-5/(4*XNP2)+(3*zeta2)/(4*XNP1)-
     /(3*zeta2)/(4*XNP2)+zeta3/XN-(2*zeta3)/XNP1+(2*zeta3)/XNP2-
     /S1N**2/(16*XN**2)+S1N**3/(48*XN)-S1NP1/(4*XNP1**2)+
     /(3*S1NP1)/(16*XNP1)+S1NP1**2/(8*XNP1**2)
     /+S1NP1**2/(8*XNP1)-S1NP1**3/(24*XNP1)+
     /S1NP2/(4*XNP2**2)-S1NP2/(4*XNP2)-
     /S1NP2**2/(8*XNP2**2)-S1NP2**2/(8*XNP2)+
     /S1NP2**3/(24*XNP2)-S2N/(16*XN**2)+(S1N*S2N)/(16*XN)
     /+S2NP1/(8*XNP1**2)-S2NP1/(8*XNP1)-
     /(S1NP1*S2NP1)/(8*XNP1)-S2NP2/(8*XNP2**2)
     /+S2NP2/(8*XNP2)+(S1NP2*S2NP2)/(8*XNP2)-S3N/(12*XN)
     /+S3NP1/(6*XNP1)-S3NP2/(6*XNP2))+
!
     /CA*(
     /43/(108*XNM1)-1/(8*XN**4)-1/(16*XN**3)
     /-7/(24*XN**2)-35/(48*XN)-
     /1/(4*XNP1**4)+1/(4*XNP1**3)+5/(12*XNP1**2)+43/(48*XNP1)-
     /11/(12*XNP2**3)-17/(18*XNP2**2)-149/(216*XNP2)-
     /zeta2/(6*XNM1)+zeta2/(8*XN**2)
     /-((-1)*zeta2)/(8*XN**2)+zeta2/(4*XN)+
     /zeta2/(4*XNP1**2)+((-1)*zeta2)/(4*XNP1**2)-(7*zeta2)/(8*XNP1)-
     /((-1)*zeta2)/(8*XNP1)+zeta2/(4*XNP2**2)
     /-((-1)*zeta2)/(4*XNP2**2)+
     /(19*zeta2)/(24*XNP2)+((-1)*zeta2)/(8*XNP2)-(5*zeta3)/(16*XN)-
     /((-1)*zeta3)/(16*XN)+(5*zeta3)/(8*XNP1)
     /+((-1)*zeta3)/(8*XNP1)-
     /(5*zeta3)/(8*XNP2)-((-1)*zeta3)/(8*XNP2)
     /-(zeta2*log2)/(8*XN)+
     /((1)*zeta2*log2)/(8*XN)-(zeta2*log2)/(4*XNP1)+
     /((1)*zeta2*log2)/(4*XNP1)
     /-(zeta2*log2)/(4*XNP2)+
     /((1)*zeta2*log2)/(4*XNP2)+log2**2/(4*XN**2)-
     /((1)*log2**2)/(4*XN**2)+log2**2/(2*XNP1**2)-
     /((1)*log2**2)/(2*XNP1**2)+log2**2/(2*XNP2**2)-
     /((1)*log2**2)/(2*XNP2**2)
     /+(log2*S1NM1f2)/(4*XN**2)-
     /((1)*log2*S1NM1f2)/(4*XN**2)
     /-(log2*S1Nf2)/(4*XN**2)+
     /((1)*log2*S1Nf2)/(4*XN**2)
     /+(log2*S1Nf2)/(2*XNP1**2)-
     /((1)*log2*S1Nf2)/(2*XNP1**2)+(zeta2*S1N)/(8*XN)+
     /((-1)*zeta2*S1N)/(8*XN)-(S1NM1f2*S1N)/(4*XN**2)+
     /((1)*S1NM1f2*S1N)/(4*XN**2)+(S1Nf2*S1N)/(4*XN**2)-
     /((1)*S1Nf2*S1N)/(4*XN**2)-S1N**3/(48*XN)-
     /(log2*S1NP1f2)/(2*XNP1**2)+((1)*log2*S1NP1f2)/
     /(2*XNP1**2)+(log2*S1NP1f2)/(2*XNP2**2)-
     /((1)*log2*S1NP1f2)/(2*XNP2**2)-
     /(3*S1NP1)/(16*XNP1)-(zeta2*S1NP1)/(4*XNP1)-
     /((-1)*zeta2*S1NP1)/(4*XNP1)-(S1Nf2*S1NP1)/(2*XNP1**2)+
     /((1)*S1Nf2*S1NP1)/(2*XNP1**2)+
     /(S1NP1f2*S1NP1)/(2*XNP1**2)-
     /((1)*S1NP1f2*S1NP1)/(2*XNP1**2)-
     /S1NP1**2/(8*XNP1)+S1NP1**3/(24*XNP1)-
     /(log2*S1NP2f2)/(2*XNP2**2)+((1)*log2*S1NP2f2)/
     /(2*XNP2**2)+S1NP2/(4*XNP2)+(zeta2*S1NP2)/(4*XNP2)+
     /((-1)*zeta2*S1NP2)/(4*XNP2)-(S1NP1f2*S1NP2)/
     /(2*XNP2**2)+((1)*S1NP1f2*S1NP2)/(2*XNP2**2)+
     /(S1NP2f2*S1NP2)/(2*XNP2**2)-
     /((1)*S1NP2f2*S1NP2)/(2*XNP2**2)+
     /S1NP2**2/(8*XNP2)-S1NP2**3/(24*XNP2)-
     /S2NM1f2/(16*XN**2)-((-1)*S2NM1f2)/(16*XN**2)+
     /((1)*S2NM1f2)/(8*XN**2)+(log2*S2NM1f2)/(16*XN)-
     /((1)*log2*S2NM1f2)/(16*XN)-(S1N*S2NM1f2)/
     /(16*XN)+((-1)*S1N*S2NM1f2)/(16*XN)+S2NM1/(6*XNM1)+
     /S2Nf2/(16*XN**2)-((-1)*S2Nf2)/(16*XN**2)-
     /((1)*S2Nf2)/(8*XN**2)-S2Nf2/(8*XNP1**2)+
     /((-1)*S2Nf2)/(8*XNP1**2)+((1)*S2Nf2)/(4*XNP1**2)-
     /((-1)*S2Nf2)/(16*XNP1)-((1)*S2Nf2)/(16*XNP1)-
     /(log2*S2Nf2)/(16*XN)+((1)*log2*S2Nf2)/(16*XN)+
     /(log2*S2Nf2)/(8*XNP1)
     /-((1)*log2*S2Nf2)/(8*XNP1)+
     /(S1N*S2Nf2)/(16*XN)+((-1)*S1N*S2Nf2)/(16*XN)-
     /(S1NP1*S2Nf2)/(8*XNP1)-((-1)*S1NP1*S2Nf2)/(8*XNP1)+
     /((-1)*S2N)/(4*XN**2)-S2N/(4*XN)-(S1NM1f2*S2N)/(8*XN)+
     /((1)*S1NM1f2*S2N)/(8*XN)+(S1Nf2*S2N)/(8*XN)-
     /((1)*S1Nf2*S2N)/(8*XN)-(3*S1N*S2N)/(16*XN)-
     /((-1)*S1N*S2N)/(4*XN)+S2NP1f2/(8*XNP1**2)+
     /((-1)*S2NP1f2)/(8*XNP1**2)-((1)*S2NP1f2)/
     /(4*XNP1**2)-((-1)*S2NP1f2)/(16*XNP1)+
     /((1)*S2NP1f2)/(16*XNP1)-S2NP1f2/(8*XNP2**2)-
     /((-1)*S2NP1f2)/(8*XNP2**2)+((1)*S2NP1f2)/
     /(4*XNP2**2)+((-1)*S2NP1f2)/(16*XNP2)-
     /((1)*S2NP1f2)/(16*XNP2)-(log2*S2NP1f2)/
     /(8*XNP1)+((1)*log2*S2NP1f2)/(8*XNP1)+
     /(log2*S2NP1f2)/(8*XNP2)-((1)*log2*S2NP1f2)/
     /(8*XNP2)+(S1NP1*S2NP1f2)/(8*XNP1)
     /-((-1)*S1NP1*S2NP1f2)/(8*XNP1)-
     /(S1NP2*S2NP1f2)/(8*XNP2)+((-1)*S1NP2*S2NP1f2)/
     /(8*XNP2)-S2NP1/(2*XNP1**2)-((-1)*S2NP1)/
     /(2*XNP1**2)+(7*S2NP1)/(8*XNP1)+
     /((-1)*S2NP1)/(4*XNP1)-(S1Nf2*S2NP1)/(4*XNP1)+
     /((1)*S1Nf2*S2NP1)/(4*XNP1)+(S1NP1f2*S2NP1)/
     /(4*XNP1)-((1)*S1NP1f2*S2NP1)/(4*XNP1)+
     /(3*S1NP1*S2NP1)/(8*XNP1)+((-1)*S1NP1*S2NP1)/
     /(2*XNP1)+S2NP2f2/(8*XNP2**2)-((-1)*S2NP2f2)/
     /(8*XNP2**2)-((1)*S2NP2f2)/(4*XNP2**2)
     /+((-1)*S2NP2f2)/(16*XNP2)+((1)*S2NP2f2)/
     /(16*XNP2)-(log2*S2NP2f2)/(8*XNP2)+
     /((1)*log2*S2NP2f2)/(8*XNP2)+
     /(S1NP2*S2NP2f2)/(8*XNP2)+((-1)*S1NP2*S2NP2f2)/
     /(8*XNP2)+((-1)*S2NP2)/(2*XNP2**2)
     /-(19*S2NP2)/(24*XNP2)-((-1)*S2NP2)/(4*XNP2)-
     /(S1NP1f2*S2NP2)/(4*XNP2)+
     /((1)*S1NP1f2*S2NP2)/(4*XNP2)+
     /(S1NP2f2*S2NP2)/(4*XNP2)
     /-((1)*S1NP2f2*S2NP2)/(4*XNP2)-
     /(3*S1NP2*S2NP2)/(8*XNP2)-((-1)*S1NP2*S2NP2)/
     /(2*XNP2)
     /-(3*S3NM1f2)/(64*XN)+((-1)*S3NM1f2)/
     /(64*XN)
     /+((1)*S3NM1f2)/(32*XN)+(3*S3Nf2)/(64*XN)
     /+((-1)*S3Nf2)/(64*XN)-((1)*S3Nf2)/(32*XN)
     /-(3*S3Nf2)/(32*XNP1)-((-1)*S3Nf2)/(32*XNP1)
     /+((1)*S3Nf2)/(16*XNP1)-S3N/(6*XN)-((-1)*S3N)/(8*XN)
     /+(3*S3NP1f2)/(32*XNP1)-((-1)*S3NP1f2)/(32*XNP1)-
     /((1)*S3NP1f2)/(16*XNP1)-(3*S3NP1f2)/(32*XNP2)+
     /((-1)*S3NP1f2)/(32*XNP2)+((1)*S3NP1f2)/
     /(16*XNP2)+S3NP1/(3*XNP1)+((-1)*S3NP1)/(4*XNP1)
     /+(3*S3NP2f2)/(32*XNP2)+((-1)*S3NP2f2)/(32*XNP2)-
     /((1)*S3NP2f2)/(16*XNP2)-S3NP2/(3*XNP2)-
     /((-1)*S3NP2)/(4*XNP2)-((-1)*Sm21N)/(4*XN)+
     /((-1)*Sm21NP1)/(2*XNP1)-((-1)*Sm21NP2)/(2*XNP2))



! NOTE: C2 coefficients have aS/Pi normalizations. Change to aS/(2*Pi)

       C2qg=4d0*C2qg
       C2NSqqb=4d0*C2NSqqb
       C2Sqqb=4d0*C2Sqqb
       C2NSqq=4d0*C2NSqq


      return
      end
      
